DECLARE FUNCTION RUN6502A& ()
DECLARE SUB Int6502 (a%)
DECLARE FUNCTION loop6502% ()
DECLARE FUNCTION CheckSprites% ()
DECLARE SUB RefreshSprite (a%, b%, c%)
DECLARE SUB RefreshLine (a%, b%)
DECLARE SUB RefreshScreen ()
DECLARE FUNCTION Joysticks% ()
DECLARE FUNCTION min% (a%, b%)
DECLARE FUNCTION ramGw& (a&)
DECLARE FUNCTION nop6502% ()
DECLARE SUB REGINC ()
DECLARE FUNCTION opcode$ (I%)
DECLARE SUB BANK.SET (p%, v%)
DECLARE SUB cmdc (cmd%, rg AS ANY)
DECLARE SUB cmdd (CMD1%, CMD2%)
DECLARE SUB cmdr (cmd%, rg%)
DECLARE SUB CODES (I%)
DECLARE SUB ENDPROG ()
DECLARE FUNCTION io_read% (a&)
DECLARE SUB io_write (a AS LONG, v%)
DECLARE SUB loadpce (f%)
DECLARE SUB M.CMP (rg1%, rg2%)
DECLARE SUB M.JR ()
DECLARE SUB M.LDWORD (rg AS ANY)
DECLARE FUNCTION MCZp% ()
DECLARE FUNCTION MCZx% ()
DECLARE FUNCTION MCZY% ()
DECLARE FUNCTION notb% (a%)
DECLARE FUNCTION op6502% (A1&)
DECLARE FUNCTION op6502w& (a&)
DECLARE FUNCTION RAMG% (a&)
DECLARE SUB ramP (a&, b%)
DECLARE FUNCTION Rd6502% (a&)
DECLARE SUB RESET6502 ()
DECLARE SUB RUN6502 ()
DECLARE SUB T_INIT (SRC&, DIST&, LENGTH&)
DECLARE FUNCTION vramg% (a%)
DECLARE SUB VRAMp (a%, b%)
DECLARE FUNCTION word& (rg AS ANY)
DECLARE SUB WORDS (rg AS ANY, A1&)
DECLARE SUB Wr6502 (a&, v%)
DECLARE SUB instr.init ()
DECLARE SUB INITVMM (SIZE%)
DECLARE SUB lockvmm (a&, b&)
DECLARE SUB VMMEND ()
DECLARE SUB vmmP (ADR&, D$)
DECLARE SUB vmmPb (ADR&, b%)
DECLARE FUNCTION allocVMM& (SIZE&)
DECLARE FUNCTION vmmGb% (ADR&)
DECLARE FUNCTION vmmGw% (ADR&)

DEFINT A-Z




'TYPE bb  'change this around for lsb fists, last
'L AS INTEGER
'H AS INTEGER
'END TYPE


'TYPE PCC
' W AS INTEGER
' B AS bb
'END TYPE

TYPE pcc
 l AS INTEGER
 h AS INTEGER
 w AS LONG
END TYPE

TYPE regg
 p AS INTEGER        'one byte register
 a AS INTEGER        '
 X AS INTEGER        '
 Y AS INTEGER        '
 S AS INTEGER        '
 PC AS pcc           'word
 NF AS INTEGER 'one byte flag (last set)
 VF AS INTEGER '
 ZF AS INTEGER '
 'cf as integer
 'df as integer


 MPR(7) AS INTEGER   'memory mapping registers pagr<->mmap (byte)
 IREQUEST AS INTEGER 'byte
 AFTERCLI AS INTEGER 'byte
 IBACKUP AS INTEGER   'int
 IPERIOD AS INTEGER 'int number of cycles to loop6502
 ICOUNT AS INTEGER  'int
 USER AS INTEGER      'VOID
 CYCLECOUNT AS INTEGER
END TYPE

TYPE ioo
 vdc(32) AS pcc              'pair
 VCE(&H200) AS pcc
 vce_reg AS pcc
 'vdc
 vdc_inc AS LONG             'word
 vdc_raster_count AS LONG
 vdc_reg AS INTEGER          'byte
 vdc_status AS INTEGER
 VDC_ratch AS INTEGER
 vce_ratch AS INTEGER
 vdc_satb AS INTEGER
 vdc_pendvsync AS INTEGER
 bg_h AS INTEGER             'integer
 bg_w AS INTEGER
 screen_w AS INTEGER
 screen_x AS INTEGER
 scroll_y AS INTEGER
 MinLine AS INTEGER
 MaxLine AS INTEGER
 'joypad
 JOY(16) AS INTEGER          'byte
 joy_select AS INTEGER
 joy_counter AS INTEGER
 'psg
  PSG(6, 8) AS INTEGER
  wave(6, 32) AS INTEGER
  wavofs(6) AS INTEGER

  '// PSG STRUCTURE
  '// 0 : dda_out
  '// 2 : freq (lo byte)  In reality it's a divisor
  '// 3 : freq (hi byte)
  '// 4 : dda_ctrl
  '//     000XXXXX
  '//     ^^  ^
  '//     ||  ch. vol
  '//     ||
  '//     |direct access (everything at byte 0)
  '//     |
  '//    enable
  '// 5 : pan (left vol = hi nibble, right vol = low nibble)
  '// 7 : noise_ctrl
  psg_ch AS INTEGER         'byte
  psg_volume AS INTEGER
  psg_lfo_freq AS INTEGER
  psg_lfo_ctrl AS INTEGER
  '/* TIMER */
  timer_reload AS INTEGER  'byte
  timer_start AS INTEGER
  timer_counter AS INTEGER
  '/* IRQ */
    irq_mask AS INTEGER    'byte
    irq_status AS INTEGER
  '/* CDROM extention */
   backup AS INTEGER          'integer
   adpcm_firstread AS INTEGER 'integer
   adpcm AS pcc               'pair
   adpcm_rptr AS LONG         'word
   adpcm_wptr AS LONG
 END TYPE





'byte = unsigned char (1)
'word = unsigned short (2)
'offset = signed char

'UNION pair
' word w
' int b {byte l,h}
'end type
' n
' n.w
' n.b (n.b.l,n.b.h)


                       '       /* 6502 status flags:         */
CONST c.flag = &H1     '       /* 1: Carry occured           */
                       '       /* notb c.flag
CONST z.flag = &H2     '       /* 1: Result is zero          */
CONST I.flag = &H4     '       /* 1: Interrupts disabled     */
CONST D.flag = &H8     '       /* 1: Decimal mode            */
'CONST b.flag = &H10    '       /* Break [0 on stk after int] */
CONST T.flag = &H20    '       /* Memory Operation Flag      */
CONST v.flag = &H40    '       /* 1: Overflow occured        */
CONST n.flag = &H80    '       /* 1: Result is negative      */

CONST nvzN.flag = NOT (z.flag OR n.flag OR v.flag) AND &HFF
CONST cn.flag = NOT c.flag AND &HFF
CONST DN.FLAG = NOT D.flag AND &HFF
CONST IN.FLAG = NOT I.flag AND &HFF
CONST Tn.flag = NOT T.flag AND &HFF



CONST byt = &HFF       '       /* byte
CONST wrd = &HFFFF&    '       /* word

CONST sh1 = &H2    'LSHIFT / RSHIFT FUNCTIONS
CONST SH2 = &H4
CONST SH3 = &H8
CONST sh4 = &H10
CONST SH5 = &H20
CONST SH6 = &H40
CONST SH7 = &H80
CONST SH8 = &H100&
CONST SH9 = &H200
CONST SHA = &H400
CONST SHB = &H800
CONST SHC = &H1000
CONST SHD = &H2000
CONST SHE = &H4000
CONST SHF = &H8000

'                      '       /* Loop6502() returns:        */
CONST INT.NONE = 0     '       /* No interrupt required      */
CONST INT.IRQ = 1      '       /* Standard IRQ interrupt     */
CONST INT.NMI = 2      '       /* Non-maskable interrupt     */
CONST INT.QUIT = 3     '       /* Exit the emulation         */

CONST INT.TIMER = 4
CONST INT.IRQ2 = 8
CONST VEC.RESET = &HFFFE&
CONST VER.NMI = &HFFFC&
CONST vec.timer = &HFFFA&
CONST VEC.IRQ = &HFFF8&
CONST VER.IRQ2 = &HFFF6&
CONST VEC.BRK = &HFFFE&
CONST zp = 0              'stack page
CONST sp = &H100          'zero page

CONST maxdisp = 227
CONST scanlines_per_frame = 263


CONST mawr = 0, marr = 1, vrr = 2, vwr = 2, cr = 5, rcr = 6, bxr = 7, byr = 8, mwr = 9, hsr = 10, hdr = 11, vpr = 12, vwr = 13




DIM SHARED reg AS regg, CYCLES%(255), I, LASTSTR, II
'DIM SHARED K AS PCC, J AS PCC
DIM SHARED CYCLE&, PAGE&(7), rommap&(255), vram&, RAM&, ioarea&, io AS ioo, ROM&
DIM SHARED ta AS pcc, COUNTER&, ts!, Pal(512)
DIM SHARED JUMPSTA(255) AS pcc, JS, JSS, JUMPSTAA(255), watch
DIM SHARED CMDSET1(255), CMDSET2(255), CMD1(255), CMD2(255), CMR1(255), CMR2(255), CMDf1(255)
CLS
CONST FILE1 = "neutop1.pce", FILE2 = "bonk3.pce", FILE3 = "BOMB94.PCE", file4 = "WONDRBOY.PCE", FILE5 = "SF2.PCE"
OPEN FILE2 FOR BINARY ACCESS READ AS #1

'used to test with hugo core
'OPEN "c:\djgpp\bin\bob" FOR INPUT AS #5
'
CLS
INITVMM 2048 * 4
loadpce 1

RESTORE cycledata: FOR II = 0 TO 255: READ CYCLES%(II): NEXT II
RESTORE CMDDSETDATA: FOR II = 0 TO 255: READ CMDSET1(II), CMDSET2(II): NEXT II
RESTORE CMDDDATA: FOR II = 0 TO 255: READ CMD1(II), CMD2(II): NEXT II
RESTORE CMDrDATA: FOR II = 0 TO 255: READ CMR1(II), CMR2(II): NEXT II



CLS
 PRINT RUN6502A
ENDPROG



cycledata:
'static byte Cycles[256] =
DATA     8,7,3, 4,6,4,6,7,3,2,2,0,7,5,7,6
DATA     2,7,7, 4,6,4,6,7,2,5,2,0,7,5,7,6
DATA     7,7,3, 4,4,4,6,7,3,2,2,0,5,5,7,6
DATA     2,7,7, 0,4,4,6,7,2,5,2,0,5,5,7,6
DATA     7,7,3, 4,8,4,6,7,3,2,2,0,4,5,7,6
DATA     2,7,7, 5,0,4,6,7,2,5,3,0,0,5,7,6
DATA     7,7,2, 0,4,4,6,7,3,2,2,0,7,5,7,6
DATA     2,7,7,17,4,4,6,7,2,5,3,0,7,5,7,6
DATA     4,7,2, 7,4,4,4,7,2,2,2,0,5,5,5,6
DATA     2,7,7, 8,4,4,4,7,2,5,2,0,5,5,5,6
DATA     2,7,2, 7,4,4,4,7,2,2,2,0,5,5,5,6
DATA     2,7,7, 8,4,4,4,7,2,5,2,0,5,5,5,6
DATA     2,7,2,17,4,4,6,7,2,2,2,0,5,5,7,6
DATA     2,7,7,17,0,4,6,7,2,5,3,0,0,5,7,6
DATA     2,7,0,17,4,4,6,7,2,2,2,0,5,5,7,6
DATA     2,7,7,17,2,4,6,7,2,5,3,0,0,5,7,0
 

CONST M.NUL = 0, m.inc = 1, M.DEC = 2, M.ROR = 3, M.ROL = 4, M.LSR = 5, m.asl = 6, TRB = 7, TSB = 8
CONST m.adc = 9, m.and = 10, m.andx = 11, m.bit = 12, m.eor = 13, m.eorx = 14
CONST m.fl = 15, m.ora = 16, m.orax = 17, m.pop = 18, m.push = 19, M.RMB = 20
CONST mm.zx = 21, MM.Zp = 22, mm.ax = 23, MM.Ab = 24
CONST mr.ab = 25, mr.ax = 26, mr.ay = 27, mr.id = 28, mr.im = 29, mr.ix = 30, mr.iy = 31, mr.zp = 32, mr.zx = 33, mr.zy = 34
CONST mw.ab = 35, mw.ax = 36, mw.ay = 37, mw.ix = 38, mw.iy = 39, mw.zp = 40, mw.zx = 41, mw.zy = 42
CONST m.sbc = 43
CONST M.SMB = 44
CONST m.adcx = 45
CONST mc.ab = 46, mc.ax = 47, mc.ay = 48, mc.id = 49, mc.ix = 50, mc.iy = 51, mc.zp = 52, mc.zx = 53, mc.zy = 54
CONST m.pop.p = 55, m.push.p = 56
'148KHZ with DEBUG OFF
'152KHZ with CMDDSETDATA
'195KHZ with (cmdr, cmdd) data
'289KHZ with LS, RS VALUES DEFINED AS CONST NOT 2 ^ B AT RUNTIME
'306khz compact code (nullerror lib) + runtime modual
'403KHZ converted some PCC statements
'416khz eleminated more PCC statements
'422KHZ ELIMINATED MORE PCC STATEMENTS ONLY REG.PC REMAINS
'25MHZ MAX SPEED (LONG INC)


'SPEED HINTS:  -DEFINE ALL CALCULATIOS THAT HAVE EXPECTED RESULTS AS CONSTS
'              -ELEMINATE WORD[S] (PCC statements)
'              -MAKE MORE DATA TABLES
'              -SIMPLIFY CODE (BEST ALTERNATIVE)




CMDDSETDATA: 'SET(F4) COMMANDS(0-FF):CMDD CMD1,CMD2  00,00 = NULL
DATA ,,30,17,,,,,,,32,17,,,,,,,29,17,,,,,,,25,17,,,,,,,31,17,28,17,,,,,33,17
DATA ,,,,,,27,17,,,,,,,26,17,,,,,,,30,11,,,,,,,32,11,,,,,,,29,11,,,,,,,25,11
DATA ,,,,,,31,11,28,11,,,,,33,11,,,,,,,27,11,,,,,,,26,11,,,,,,,30,14,,,,,,
DATA 32,14,,,,,,,29,14,,,,,,,25,14,,,,,,,31,14,28,14,,,,,33,14,,,,,,,27,14
DATA ,,,,,,26,14,,,,,,,30,45,,,,,,,32,45,,,,,,,29,45,,,,,,,25,45,,,,,,,31,45
DATA 28,45,,,,,33,45,,,,,,,27,45,,,,,,,26,45,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,
DATA ,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,
DATA ,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,
DATA ,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,
DATA ,,,,,,,,,,,,,,,,,,,

CMDDDATA:
DATA ,,30,16,,,,,,,32,16,,,,,,,29,16,,,,,,,25,16,,,,,,,31,16,28,16,,,,,33,16
DATA ,,,,,,27,16,,,,,,,26,16,,,,,,,30,10,,,,,32,12,32,10,,,,,,,29,10,,,,,25,12
DATA 25,10,,,,,,,31,10,28,10,,,33,12,33,10,,,,,,,27,10,,,,,26,12,26,10,,,,
DATA ,,30,13,,,,,,,32,13,,,,,,,29,13,,,,,,,25,13,,,,,,,31,13,28,13,,,,,33,13
DATA ,,,,,,27,13,,,,,,,26,13,,,,,,,30,9,,,,,,,32,9,,,,,,,29,9,,,,,,,25,9,,
DATA ,,,,31,9,28,9,,,,,33,9,,,,,,,27,9,,,,,,,26,9,,,,,,,,,,,,,,,,,,,,,,,29,12
DATA ,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,
DATA ,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,
DATA ,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,30,43,,,,,,,32,43,,,,,,,29,43,,,,,,
DATA 25,43,,,,,,,31,43,28,43,,,,,33,43,,,,,,,27,43,,,,,,,26,43,,,,

CMDrDATA:
DATA ,,,,,,,,22,8,,,22,6,20,1,,,,,,,,,24,8,,,24,6,,,,,,,,,,,22,7,,,21,6,20,2
DATA ,,,,,,,,24,7,,,23,6,,,,,,,,,,,,,,,22,4,20,4,,,,,,,,,,,,,24,4,,,,,,,,
DATA ,,,,,,21,4,20,8,,,,,,,,,,,,,23,4,,,,,,,,,,,,,,,22,5,20,16,,,,,,,,,,,,
DATA 24,5,,,,,,,,,,,,,,,21,5,20,32,,,,,,,,,,,,,23,5,,,,,,,,,,,40,,,,22,3,20,64
DATA ,,,,,,,,,,,,24,3,,,,,,,,,,,41,,,,21,3,20,128,,,,,,,,,,,,,23,3,,,,,,,,
DATA ,,,,,,,,44,1,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,44,2,,,,,,,,,35,,,,36,,,,,
DATA ,,,,,,,,,,,,44,4,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,44,8,,,,,,,,,,,,,,,,,,
DATA ,,,,,,,,,,22,2,44,16,,,,,,,,,,,,,24,2,,,,,,,,,,,,,,,21,2,44,32,,,,,,
DATA ,,,,,,23,2,,,,,,,,,,,,,,,22,1,44,64,,,,,,,,,,,,,24,1,,,,,,,,,,,,,,,21,1
DATA 44,128,,,,,,,,,,,,,23,1,,

CMDfDATA: 'first cmdr or cmdc executed by an funvtion 0 - ff
DATA ,,,,,,,,56,,6,,,,,,,,,,,,,,,,1,,,,,,,,,,,,,,55,,4,,,,,,,,,,,,,,,,2,,
DATA ,,,,,,,,,,,19,,5,,,,,,,,,,,,,,,,19,,,,,,,,,,,,,,18,,3,,,,,,,,,,,,,,,
DATA 18,,,,,,,38,,,40,40,40,,15,,15,,35,35,35,,,39,49,25,41,41,42,,15,37,
DATA ,,36,,,29,30,29,,32,32,32,,15,29,15,,25,25,25,,,31,28,26,33,33,34,,,27
DATA 15,,26,26,27,,29,30,,,32,32,,,15,29,15,,25,25,,,,31,28,,,33,,,,27,19

SUB BANK.SET (p, v)

IF rommap&(v) = ioarea& THEN
PAGE&(p) = ioarea&
ELSE
PAGE&(p) = rommap&(v) - p * 8192&


END IF
END SUB

FUNCTION CheckSprites ()
END FUNCTION

SUB cmdc (cmd, rg&)
SELECT CASE cmd
CASE 0: PRINT "error cmdc": ENDPROG

CASE mc.ab
   M.LDWORD rg&
CASE mc.ax
   M.LDWORD rg&
   rg& = rg& + reg.X
CASE mc.ay
   M.LDWORD rg&
   rg& = rg& + reg.Y
CASE mc.id    '''''WORD RAM READ
  rg& = MCZp()
  'rg.L = RAMG((A%))
  'rg.H = RAMG(A% + 1)
  'rg& = word(rg)
  rg& = ramGw(rg&)

CASE mc.ix      'WORD RAM READ
  rg& = MCZx()
  'rg.L = RAMG((A%))
  'rg.H = RAMG((A%))
 'rg.w = word(rg)
  rg& = ramGw(rg&)
CASE mc.iy
  rg& = MCZp()    'WORD RAM REED
  'rg.L = RAMG((A%)): rg.H = RAMG(A% + 1)
  'WORDS rg, word(rg) + reg.y
  rg& = ramGw(rg&) + reg.Y
CASE mc.zp
  'RG.L = nop6502     'since zp=0  h:l -> 0:l
  'RG.H = zp \ SH8
  'RG.W = word(RG)

   rg& = nop6502
CASE mc.zx
  'RG.L = nop6502 + ReG.X
  'RG.H = zp \ SH8
  'RG.W = word(RG)
   rg& = nop6502 + reg.X
CASE mc.zy
  'rg.L = nop6502 + reg.Y
  'rg.H = zp \ SH8
  'rg.w = word(rg)
   rg& = nop6502 + reg.Y
CASE ELSE
  PRINT "Invalid CmdC"; cmd: ENDPROG
END SELECT


END SUB

SUB cmdcf (rg)
cmdr CMDf1(I), rg
END SUB

SUB cmdd (CMD1, CMD2)
cmdr CMD1, I
cmdr CMD2, I
END SUB

STATIC SUB cmdr (cmd, rg)

SELECT CASE cmd
CASE M.NUL:
PRINT "error: CmdRg Null "; HEX$(LASTSTR): ENDPROG
CASE m.adc 'm.adc 'NOTE: NOT (K AS PCC DEPENDENT)

  IF (reg.p AND D.flag) THEN 'decimal mode (#a + rg + cf ) -> (cf:#a)


  K.L = (reg.a AND &HF) + (rg AND &HF) + (reg.p AND c.flag)
  K.H = (reg.a \ sh4) + (rg \ sh4)
    IF (K.L > 9) THEN K.L = K.L + 6: K.H = K.H + 1
    IF (K.H > 9) THEN K.H = K.H + 6
    reg.a = ((K.L AND &HF) OR (K.H * sh4)) AND &HFF

    IF K.H > 15 THEN reg.p = reg.p OR c.flag ELSE reg.p = reg.p AND cn.flag
    
    
    'ZF = NF = A
    reg.ZF = reg.a
    reg.NF = reg.a
                CYCLE& = CYCLE& + 1

  ELSE 'hex mode (#a + rg + cf ) -> (cf:#a)

    a% = reg.a + rg + (reg.p AND c.flag)
    IF a% AND &HFF00 THEN reg.p = reg.p OR c.flag:  ELSE reg.p = reg.p AND cn.flag
    a% = a% AND &HFF
    reg.VF = (notb(reg.a XOR rg) AND (reg.a XOR a%)) \ sh1
    reg.ZF = a%
    reg.NF = a%
    reg.a = a%
   END IF
CASE m.adcx  'NOTE: NOT (K AS PCC DEPENDENT)
 'MX = AdrRAM(reg.X + ZP)
  MX = RAMG(reg.X + zp)
  IF (reg.p AND D.flag) THEN

    K.L = (MX AND &HF) + (rg AND &HF) + (reg.p AND c.flag)
    K.H = (MX \ sh4) + (rg \ sh4)';/*+(K.l>>4);*/ \
    IF (K.L > 9) THEN K.L = K.L + 6: K.H = K.H + 1
    IF (K.H > 9) THEN K.H = K.H + 6
    MX = ((K.L AND &HF) OR (K.H * sh4)) AND &HFF

    IF K.H > 15 THEN reg.p = reg.p OR c.flag ELSE reg.p = reg.p AND cn.flag
    'ZF = NF = A
    reg.ZF = MX
    reg.NF = MX


    CYCLE& = CYCLE& + 1

  ELSE

    a% = MX + rg + (reg.p AND c.flag)
    
    IF a% AND &HFF00 THEN reg.p = reg.p OR c.flag ELSE reg.p = reg.p AND cn.flag
    a% = a% AND &HFF
    reg.VF = (notb(MX XOR rg) AND (MX XOR a%)) \ sh1
    reg.ZF = a%
    reg.NF = a%

    MX = a%

 END IF
 'AdrRAM(reg.X + ZP) = MX
  ramP reg.X + zp, MX

CASE m.and
  reg.a = reg.a AND rg
  cmdr m.fl, reg.a
CASE m.andx
   'AdrRAM(reg.x + zp) = AdrRAM(reg.x + zp) AND RG
   ramP reg.X + zp, RAMG(reg.X + zp) AND rg
   cmdr m.fl, RAMG(reg.X + zp)

CASE m.asl
   reg.p = reg.p AND cn.flag
   reg.p = reg.p OR rg \ SH7
   rg = (rg * sh1) AND &HFF
   cmdr m.fl, rg

CASE m.bit
  reg.NF = rg
  reg.VF = rg
  reg.ZF = rg AND reg.a
CASE m.inc
  rg = rg + 1
  cmdr m.fl, rg

CASE M.DEC
  rg = rg - 1
  cmdr m.fl, rg


CASE M.ROR
  a% = (rg \ sh1) OR (reg.p * SH7)
  reg.p = reg.p AND cn.flag
  reg.p = reg.p OR (rg AND c.flag)
  'rg = A%     'to fix possible overflow
  cmdr m.fl, a%
  rg = a%
CASE M.ROL
  a% = (rg * sh1) OR (reg.p AND c.flag)
  reg.p = reg.p AND cn.flag
  reg.p = reg.p OR (rg \ SH7)
  'rg = A% to fix possible overflow
  cmdr m.fl, a%
  rg = a%
CASE M.LSR
  reg.p = reg.p AND cn.flag
  reg.p = reg.p OR (rg AND c.flag)
  rg = rg \ sh1
  cmdr m.fl, rg

CASE TRB

  'NF=VF=RG
  reg.NF = rg
  reg.VF = rg
  rg = rg AND notb(reg.a)
  reg.ZF = rg

CASE TSB:
  'NF=VF=RG
  reg.NF = rg
  reg.VF = rg
  rg = rg OR reg.a
  reg.ZF = rg
CASE m.eor
  reg.a = reg.a XOR rg
  cmdr m.fl, reg.a
CASE m.eorx
  'AdrRAM(reg.x + zp) = AdrRAM(reg.x + zp) XOR RG
  ramP reg.X + zp, RAMG(reg.X + zp) XOR rg
  cmdr m.fl, RAMG(reg.X + zp)
CASE m.fl
  'ZF=NF=RG


  rg = rg AND &HFF  'flow control if needed 0 -> ff -> 0
  reg.ZF = rg
  reg.NF = rg
CASE m.ora
  reg.a = reg.a OR rg
  cmdr m.fl, reg.a
CASE m.orax
  'AdrRAM(reg.x + zp) = AdrRAM(reg.x + zp) OR RG
  ramP reg.X + zp, RAMG(reg.X + zp) OR rg
  cmdr m.fl, RAMG(reg.X + zp)
CASE m.pop
  reg.S = (reg.S + 1) AND &HFF      'does this fix overflow
  rg = RAMG(sp + reg.S)
CASE m.push
  ramP sp + reg.S, rg
  reg.S = (reg.S - 1) AND &HFF      'does this fix overflow
CASE m.pop.p
cmdr m.pop, rg
reg.NF = rg
reg.VF = rg
IF rg AND z.flag THEN reg.ZF = 0 ELSE reg.ZF = 1
CASE m.push.p

IF reg.ZF THEN tmp = 0 ELSE tmp = z.flag
cmdr m.push, ((rg) AND nvzN.flag) OR (reg.NF AND n.flag) OR (reg.VF AND v.flag) OR tmp

CASE M.RMB
  'AdrRAM(MCZp()) = AdrRAM(MCZp()) AND NOT (N)
  ramP MCZp(), RAMG(MCZp()) AND notb(rg)
CASE m.sbc 'NOTE: NOT (K AS PCC) DEPENDENT
  '/* Warning! C_FLAG is inverted before SBC and after it */
    IF (reg.p AND D.flag) THEN

      K.L = ((reg.a AND &HF) - (rg AND &HF) - (notb(reg.p) AND c.flag)) AND &HFF
      IF (K.L AND &H10) THEN K.L = K.L - 6
      K.H = ((reg.a \ sh4) - (rg \ sh4) + ((K.L AND &H10) = &H10)) AND &HFF
      IF (K.H AND &H10) THEN K.H = K.H - 6
      reg.a = (K.L AND &HF) OR (K.H * sh4) AND &HFF

      IF K.H AND &H10 THEN reg.p = reg.p AND cn.flag ELSE reg.p = reg.p OR c.flag

                  CYCLE& = CYCLE& + 1

    ELSE

      a% = reg.a - rg - (notb(reg.p) AND c.flag)
      IF a% AND &HFF00 THEN reg.p = reg.p AND cn.flag ELSE reg.p = reg.p OR c.flag
      reg.VF = ((reg.a XOR rg) AND (reg.a XOR a%)) \ sh1
      reg.ZF = a%
      reg.NF = a%
      reg.a = a% AND &HFF
    END IF
CASE M.SMB
  'AdrRAM(MCZp()) = AdrRAM(MCZp()) OR N
  ramP MCZp(), RAMG(MCZp()) OR rg
CASE MM.Ab
  'cmdc mc.ab, A&
  M.LDWORD a& 'GET MEMORY LOCATION
  I = Rd6502(a&)
  cmdr rg, I
  Wr6502 a&, I
CASE mm.ax
  cmdc mc.ax, a&
  I = Rd6502(a&)
  cmdr rg, I
  Wr6502 a&, I
CASE MM.Zp
  a& = MCZp()
  I = RAMG(a&)
  cmdr rg, I
  ramP a&, I

CASE mm.zx
  a& = MCZx()
  I = RAMG(a&)
  cmdr rg, I
  ramP a&, I

CASE mr.ab
 'cmdc mc.ab, A& 'READ MEMORY LOCATION
 M.LDWORD a&
 rg = Rd6502(a&)

CASE mr.ax
  cmdc mc.ax, a&
  rg = Rd6502(a&)
CASE mr.ay
  cmdc mc.ay, a&
  rg = Rd6502(a&)
CASE mr.id
  cmdc mc.id, a&
  rg = Rd6502(a&)
CASE mr.im
  rg = nop6502
CASE mr.ix
  cmdc mc.ix, a&
  rg = Rd6502(a&)
CASE mr.iy
  cmdc mc.iy, a&
  rg = Rd6502(a&)
CASE mr.zp
  rg = RAMG(MCZp())
CASE mr.zx
  rg = RAMG(MCZx())
CASE mr.zy
  rg = RAMG(MCZY())
CASE mw.ab
  'cmdc mc.ab, A&
  M.LDWORD a& 'GET MEMORY LOCATION
  Wr6502 a&, rg
CASE mw.ax
  cmdc mc.ax, a&
  Wr6502 a&, rg
CASE mw.ay
  cmdc mc.ay, a&
  Wr6502 a&, rg
CASE mw.ix
  cmdc mc.ix, a&
  Wr6502 a&, rg
CASE mw.iy
  cmdc mc.iy, a&
  Wr6502 a&, rg
CASE mw.zp
  ramP MCZp(), rg
CASE mw.zx
  ramP MCZx(), rg
CASE mw.zy
  ramP MCZY(), rg

CASE ELSE
PRINT "error: CmdRg not found(" + HEX$(cmd) + ")": ENDPROG
END SELECT
IF (rg AND byt) <> rg THEN PRINT "Error:byte overflow"; rg: ENDPROG



END SUB

SUB cmdrf (a)
cmdr CMDf1(I), a

END SUB

STATIC SUB CODES (I)
COUNTER& = COUNTER& + 1
LASTSTR = I

'used to test with hugo core
' LINE INPUT #5, FF$
' FF$ = UCASE$(FF$)
'watch = 1

'IF REG.PC.W - 1 = &HD509& THEN WATCH = -1
'IF COUNTER& = &H28990 THEN WATCH = 1
IF watch = 1 THEN
WW = RAMG(3)

watch = 2
'PRINT UCASE$(ff$)
PRINT "RL="; HEX$(PAGE&((reg.PC.w - 1) \ SHD) + reg.PC.w - 1 - ROM&); " PC="; HEX$(reg.PC.w - 1); " A="; HEX$(reg.a); " P="; HEX$(reg.p); " S="; HEX$(reg.S); " X="; HEX$(reg.X); " Y="; HEX$(reg.Y);
PRINT " NF="; HEX$(reg.NF); " VF="; HEX$(reg.VF); " ZF="; HEX$(reg.ZF); " ";
IF WW THEN PRINT "ZP3"; " ";
'PRINT CYCLE& / (TIMER - ts!);
'PRINT counter&;
'PRINT cycle&;
PRINT "OP="; HEX$(I); " "; opcode$(I); " "; 'HEX$(I), cycle&

END IF

'RR$ = "RL=" + HEX$(PAGE&((reg.PC.w - 1) \ SHD) + reg.PC.w - 1 - ROM&) + " PC=" + HEX$(reg.PC.w - 1) + " A=" + HEX$(reg.a) + " P=" + HEX$(reg.p) + " S=" + HEX$(reg.S) + " X=" + HEX$(reg.X) + " Y=" + HEX$(reg.Y)
'RR$ = RR$ + " NF=" + HEX$(reg.NF AND &HFF) + " VF=" + HEX$(reg.VF AND &HFF) + " ZF=" + HEX$(reg.ZF AND &HFF) + " OP=" + HEX$(I)


'used to test with hugo core
' IF FF$ <> RR$ THEN
' PRINT
' PRINT "MISMATCH OP #" + HEX$(COUNTER&) + " CYCLE #" + HEX$(CYCLE&)
' PRINT RRR$; " "; OOO$
' PRINT FF$
' PRINT RR$; " "; opcode$(I)
' ENDPROG
' END IF

'OOO$ = opcode$(I)
'RRR$ = RR$

'LINE INPUT #3, f$
'PRINT f$

SELECT CASE I
CASE &HD4'/* CSH set clock highspeed */
CASE &H54'/* CSL set clock lowspeed */

CASE &H44: '/* BSR * REL */   'FIXED
           WORDS reg.PC, reg.PC.w
           cmdr m.push, reg.PC.h
           cmdr m.push, reg.PC.l
           I = op6502(reg.PC.w)
           I = I + (I > 127) * 256
  JUMPSTA(JS).w = reg.PC.w
  JS = JS + 1
  JSS = JSS + 1
  
           reg.PC.w = reg.PC.w + I + 1

CASE &H80: '/* BRA * REL */
          I = op6502(reg.PC.w)
          I = I + (I > 127) * 256
          reg.PC.w = reg.PC.w + I + 1
CASE &H7C: '/* JMP ($ssss,x) */
        M.LDWORD a&: a& = a& + reg.X
        reg.PC.w = op6502w&(a&)

CASE &HDA: cmdr m.push, reg.X  '  /* PHX */
CASE &H5A: cmdr m.push, reg.Y '               /* PHY */
CASE &HFA: cmdr m.pop, reg.X: cmdr m.fl, reg.X '    /* PLX */
CASE &H7A: cmdr m.pop, reg.Y: cmdr m.fl, reg.Y'      /* PLY */

CASE &H62: reg.a = 0' /* CLA */
CASE &H82: reg.X = 0' /* CLX */
CASE &HC2: reg.Y = 0' /* CLY */

CASE &H2:  I = reg.X: reg.X = reg.Y: reg.Y = I'  /* SXY */
CASE &H22: I = reg.a: reg.a = reg.X: reg.X = I'  /* SAX */
CASE &H42: I = reg.a: reg.a = reg.Y: reg.Y = I'  /* SAY */

CASE &H3A: cmdr M.DEC, reg.a                  ' /* DEC A */
CASE &H1A: cmdr m.inc, reg.a                  ' /* INC A */



CASE &HD2: cmdr mr.id, I: M.CMP reg.a, I       '/* CMP ($ss) INDIR */
CASE &HB2: cmdr mr.id, reg.a: cmdr m.fl, reg.a '/* LDA ($ss) INDIR */
CASE &H92: cmdc mc.id, a&: Wr6502 a&, reg.a'/* STA ($ss) INDIR */

CASE &HF4: ' /* SET */
        I = nop6502
        CYCLE& = CYCLE& + CYCLES(I) + 3
        cmdd CMDSET1(I), CMDSET2(I)  'IF ERROR, TAKE BACK OFF CYCLES(I)


CASE &H3: io_write 0, nop6502  '/* ST0 */
CASE &H13: io_write 2, nop6502 '/* ST1 */
CASE &H23: io_write 3, nop6502 '/* ST2 */

CASE &H43: '/* TMAi */
          I = nop6502
          FOR II = 0 TO 7
              IF (I AND 2 ^ II) THEN EXIT FOR
          NEXT II
          reg.a = reg.MPR(II)
CASE &H53: '/* TAMi */
        I = nop6502
         FOR II = 0 TO 7
              IF I AND 2 ^ II THEN reg.MPR(II) = reg.a: BANK.SET II, reg.a
         NEXT II

CASE &HC3: ' /* TDD */
        T_INIT SRC&, DIST&, LENGTH&
        DO
        Wr6502 DIST&, Rd6502(SRC&)
        DIST& = DIST& - 1
        SRC& = SRC& - 1
        LENGTH& = LENGTH& - 1
        LOOP WHILE LENGTH&

CASE &H73: ' /* TII */
        T_INIT SRC&, DIST&, LENGTH&
        DO
             Wr6502 DIST&, Rd6502(SRC&)
             DIST& = DIST& + 1
             SRC& = SRC& + 1
             LENGTH& = LENGTH& - 1
        LOOP WHILE LENGTH&


CASE &HE3: ' /* TIA */
        T_INIT SRC&, DIST&, LENGTH&
        DO
                Wr6502 DIST&, Rd6502(SRC&)
                SRC& = SRC& + 1
                LENGTH& = LENGTH& - 1
                IF LENGTH& = 0 THEN EXIT DO
                Wr6502 DIST& + 1, Rd6502(SRC&)
                SRC& = SRC& + 1
                lenght& = LENGTH& - 1
        LOOP WHILE LENGTH&


CASE &HF3: ' /* TAI */

        T_INIT SRC&, DIST&, LENGTH&

         DO
               Wr6502 DIST&, Rd6502(SRC&)
               DIST& = DIST& + 1
               LENGTH& = LENGTH& - 1
               IF LENGTH& = 0 THEN EXIT DO
               Wr6502 DIST&, Rd6502(SRC& + 1)
               DIST& = DIST& + 1
               LENGTH& = LENGTH& - 1
         LOOP WHILE LENGTH&
        

CASE &HD3: ' /* TIN */
        T_INIT SRC&, DIST&, LENGTH&
        DO
                Wr6502 DIST&, Rd6502(SRC&)
                SRC& = SRC& + 1
                LENGTH& = LENGTH& - 1
        LOOP WHILE LENGTH&


CASE &H83: '/* TST #$ss,$ss IMM,ZP */
        I = nop6502: II = RAMG(MCZp())
        reg.NF = II
        reg.VF = II: reg.ZF = I AND II

CASE &HA3: '/* TST #$ss,$ss,x IMM,ZP,x */
        I = nop6502: II = RAMG(MCZx())
        reg.NF = II
        reg.VF = II: reg.ZF = I AND II
CASE &H93: '/* TST #$ss,$ssss IMM,ABS */
        I = nop6502: cmdr mr.ab, II
        reg.NF = II
        reg.VF = II: reg.ZF = I AND II

CASE &HB3: '/* TST #$ss,$ssss,x IMM,ABS,x */
        I = nop6502: cmdr mr.ax, II
        reg.NF = II
        reg.VF = II: reg.ZF = I AND II

'SBC
 
CASE &H10: IF (reg.NF AND n.flag) THEN REGINC ELSE M.JR  '/* BPL * REL */
CASE &H30: IF (reg.NF AND n.flag) THEN M.JR ELSE REGINC  '/* BMI * REL */
CASE &HD0: IF reg.ZF = 0 THEN REGINC ELSE M.JR      '/* BNE * REL */
CASE &HF0: IF reg.ZF = 0 THEN M.JR ELSE REGINC     '/* BEQ * REL */
CASE &H90: IF (reg.p AND c.flag) THEN REGINC ELSE M.JR '/* BCC * REL */
CASE &HB0: IF (reg.p AND c.flag) THEN M.JR ELSE REGINC '/* BCS * REL */
CASE &H50: IF (reg.VF AND v.flag) THEN REGINC ELSE M.JR'/* BVC * REL */
CASE &H70: IF (reg.VF AND v.flag) THEN M.JR ELSE REGINC '/* BVS * REL */


CASE &H40: '/* RTI */

  I = reg.p


  cmdr m.pop.p, reg.p

  IF ((reg.IREQUEST <> INT.NONE) AND (I AND I.flag) <> 0 AND NOT (reg.p AND I.flag) <> 0) THEN
     REGAfterCLI = 1
    reg.IBACKUP = reg.ICOUNT
    reg.ICOUNT = 0
    END IF
    cmdr m.pop, reg.PC.l
    cmdr m.pop, reg.PC.h


CASE &H60: '/* RTS */
  v& = reg.PC.w - 1
  cmdr m.pop, reg.PC.l: cmdr m.pop, reg.PC.h': REGINC REG.PC
  reg.PC.w = word(reg.PC) + 1
  JS = JS - 1
  O& = JUMPSTA(JS).w + 1
  JUMPSTA(JS).w = 0
  IF watch = 2 THEN PRINT "(" + HEX$(O&) + ")"; " ";
  IF reg.PC.w <> O& THEN
  PRINT "RTS @" + HEX$(v&); "GOTO " + HEX$(O&); "WENT " + HEX$(reg.PC.w)
  PRINT "RTS #" + HEX$(JSS) + "RTS STACK #"; JS
  END IF
CASE &H20: '/* JSR $ssss ABS */
  a& = op6502w&(reg.PC.w): REGINC
  cmdr m.push, reg.PC.h
  cmdr m.push, reg.PC.l
  
  JUMPSTA(JS).w = reg.PC.w
  JS = JS + 1
  JSS = JSS + 1
  reg.PC.w = a&
CASE &H4C: M.LDWORD a&: reg.PC.w = a&'/* JMP $ssss ABS */

CASE &H6C: '/* JMP ($ssss) ABDINDIR */
  M.LDWORD a&
  reg.PC.w = op6502w&(a&)

CASE &H0: '/* BRK */
  REGINC
  cmdr m.push, reg.PC.h: cmdr m.push, reg.PC.l
  cmdr m.push.p, reg.p AND Tn.flag OR (b.flag)
  reg.p = (reg.p OR I.flag) AND DN.FLAG
  a& = reg.PC.w
  reg.PC.l = op6502(VEC.BRK)
  reg.PC.h = op6502(VEC.BRK + 1)
  PRINT ERR, "BRK instruction " + HEX$(a& - 1)
  ENDPROG

CASE &H58: '/* CLI */
  IF ((reg.IREQUEST <> INT.NONE) AND (reg.p AND I.flag) <> 0) THEN
  
    reg.AFTERCLI = 1
    reg.IBACKUP = reg.ICOUNT
    reg.ICOUNT = 0

  END IF
  reg.p = reg.p AND IN.FLAG



CASE &H28: '/* PLP */
  cmdr m.pop.p, I

  IF ((reg.IREQUEST <> INT.NONE) AND ((I XOR reg.p) AND notb(I) AND I.flag) <> 0) THEN

    reg.AFTERCLI = 1
    reg.IBACKUP = reg.ICOUNT
    reg.ICOUNT = 0

  END IF
  reg.p = I



CASE &H8: cmdr m.push.p, reg.p AND Tn.flag OR b.flag'     /* PHP */
CASE &H18: reg.p = reg.p AND cn.flag          '     /* CLC */
CASE &HB8: reg.VF = 0                              '     /* CLV */
CASE &HD8: reg.p = reg.p AND DN.FLAG          '     /* CLD */
CASE &H38: reg.p = reg.p OR c.flag                 '     /* SEC */
CASE &HF8: reg.p = reg.p OR D.flag                 '     /* SED */
CASE &H78: reg.p = reg.p OR I.flag                 '     /* SEI */
CASE &H48: cmdr m.push, reg.a          '             /* PHA */
CASE &H68: cmdr m.pop, reg.a: cmdr m.fl, reg.a       '     /* PLA */
CASE &H98: reg.a = reg.Y: cmdr m.fl, reg.a     '     /* TYA */

'can i use cmdr m.inc, reg.y ?
CASE &HA8: reg.Y = reg.a: cmdr m.fl, reg.Y     '     /* TAY */
CASE &HC8: reg.Y = reg.Y + 1: cmdr m.fl, reg.Y '     /* INY */
CASE &H88: reg.Y = reg.Y - 1: cmdr m.fl, reg.Y '     /* DEY */
CASE &H8A: reg.a = reg.X: cmdr m.fl, reg.a     '     /* TXA */
CASE &HAA: reg.X = reg.a: cmdr m.fl, reg.X     '     /* TAX */
CASE &HE8: reg.X = reg.X + 1: cmdr m.fl, reg.X '     /* INX */
CASE &HCA: reg.X = reg.X - 1: cmdr m.fl, reg.X '     /* DEX */
CASE &HEA:  '                                  /* NOP */
CASE &H9A: reg.S = reg.X                 '     /* TXS */
CASE &HBA: reg.X = reg.S: cmdr m.fl, reg.X     '     /* TSX */
CASE &H84: cmdr mw.zp, reg.Y                 '  /* STY $ss ZP */
CASE &H85: cmdr mw.zp, reg.a                '  /* STA $ss ZP */
CASE &H86: cmdr mw.zp, reg.X                 '  /* STX $ss ZP */
CASE &HA4: cmdr mr.zp, reg.Y: cmdr m.fl, reg.Y    '  /* LDY $ss ZP */
CASE &HA5: cmdr mr.zp, reg.a: cmdr m.fl, reg.a    '  /* LDA $ss ZP */
CASE &HA6: cmdr mr.zp, reg.X: cmdr m.fl, reg.X     '  /* LDX $ss ZP */
CASE &HC4: cmdr mr.zp, I: M.CMP reg.Y, I     '  /* CPY $ss ZP */
CASE &HC5: cmdr mr.zp, I: M.CMP reg.a, I     '  /* CMP $ss ZP */
CASE &HE4: cmdr mr.zp, I: M.CMP reg.X, I    '  /* CPX $ss ZP */
CASE &H8C: cmdr mw.ab, reg.Y                 '  /* STY $ssss ABS */
CASE &H8D: cmdr mw.ab, reg.a               '  /* STA $ssss ABS */
CASE &H8E: cmdr mw.ab, reg.X                '  /* STX $ssss ABS */
CASE &HAC: cmdr mr.ab, reg.Y: cmdr m.fl, reg.Y     '  /* LDY $ssss ABS */
CASE &HAD: cmdr mr.ab, reg.a: cmdr m.fl, reg.a    '  /* LDA $ssss ABS */
CASE &HAE: cmdr mr.ab, reg.X: cmdr m.fl, reg.X     '  /* LDX $ssss ABS */
CASE &HCC: cmdr mr.ab, I: M.CMP reg.Y, I     '  /* CPY $ssss ABS */
CASE &HCD: cmdr mr.ab, I: M.CMP reg.a, I     '  /* CMP $ssss ABS */
CASE &HEC: cmdr mr.ab, I: M.CMP reg.X, I    '  /* CPX $ssss ABS */
CASE &HA0: cmdr mr.im, reg.Y: cmdr m.fl, reg.Y     '  /* LDY #$ss IMM */
CASE &HA2: cmdr mr.im, reg.X: cmdr m.fl, reg.X     '  /* LDX #$ss IMM */
CASE &HA9: cmdr mr.im, reg.a: cmdr m.fl, reg.a     '  /* LDA #$ss IMM */
CASE &HC0: cmdr mr.im, I: M.CMP reg.Y, I     '  /* CPY #$ss IMM */
CASE &HC9: cmdr mr.im, I: M.CMP reg.a, I     '  /* CMP #$ss IMM */
CASE &HE0: cmdr mr.im, I: M.CMP reg.X, I    '  /* CPX #$ss IMM */
CASE &H94: cmdr mw.zx, reg.Y                 '  /* STY $ss,x ZP,x */
CASE &H95: cmdr mw.zx, reg.a                 '  /* STA $ss,x ZP,x */
CASE &H96: cmdr mw.zy, reg.X                 '  /* STX $ss,y ZP,y */
CASE &HB4: cmdr mr.zx, reg.Y: cmdr m.fl, reg.Y     '  /* LDY $ss,x ZP,x */
CASE &HB5: cmdr mr.zx, reg.a: cmdr m.fl, reg.a     '  /* LDA $ss,x ZP,x */
CASE &HB6: cmdr mr.zy, reg.X: cmdr m.fl, reg.X     '  /* LDX $ss,y ZP,y */
CASE &HD5: cmdr mr.zx, I: M.CMP reg.a, I     '  /* CMP $ss,x ZP,x */
CASE &H99: cmdr mw.ay, reg.a                 '  /* STA $ssss,y ABS,y */
CASE &H9D: cmdr mw.ax, reg.a                 '  /* STA $ssss,x ABS,x */
CASE &HB9: cmdr mr.ay, reg.a: cmdr m.fl, reg.a     '  /* LDA $ssss,y ABS,y */
CASE &HBC: cmdr mr.ax, reg.Y: cmdr m.fl, reg.Y     '  /* LDY $ssss,x ABS,x */
CASE &HBD: cmdr mr.ax, reg.a: cmdr m.fl, reg.a     '  /* LDA $ssss,x ABS,x */
CASE &HBE: cmdr mr.ay, reg.X: cmdr m.fl, reg.X     '  /* LDX $ssss,y ABS,y */
CASE &HD9: cmdr mr.ay, I: M.CMP reg.a, I     '  /* CMP $ssss,y ABS,y */
CASE &HDD: cmdr mr.ax, I: M.CMP reg.a, I     '  /* CMP $ssss,x ABS,x */
CASE &H81: cmdr mw.ix, reg.a                 '  /* STA ($ss,x) INDEXINDIR */
CASE &H91: cmdr mw.iy, reg.a                 '  /* STA ($ss),y INDIRINDEX */
CASE &HA1: cmdr mr.ix, reg.a: cmdr m.fl, reg.a     '  /* LDA ($ss,x) INDEXINDIR */
CASE &HB1: cmdr mr.iy, reg.a: cmdr m.fl, reg.a     '  /* LDA ($ss),y INDIRINDEX */
CASE &HC1: cmdr mr.ix, I: M.CMP reg.a, I     '  /* CMP ($ss,x) INDEXINDIR */
CASE &HD1: cmdr mr.iy, I: M.CMP reg.a, I     '  /* CMP ($ss),y INDIRINDEX */
CASE &HA:  cmdr m.asl, reg.a                 '  /* ASL a ACC */
CASE &H2A: cmdr M.ROL, reg.a                '  /* ROL a ACC */
CASE &H4A: cmdr M.LSR, reg.a                '  /* LSR a ACC */
CASE &H6A: cmdr M.ROR, reg.a                '  /* ROR a ACC */

CASE IS = ((CMD1(I) <> 0) AND I): cmdd (CMD1(I)), (CMD2(I))
CASE IS = ((CMR1(I) <> 0) AND I): cmdr (CMR1(I)), (CMR2(I))
CASE IS = (I OR &H8F) '/BBSi
IF (RAMG(MCZp())) AND (2 ^ ((I XOR &H80) \ sh4)) THEN M.JR ELSE REGINC 'BBRI
CASE IS = (I OR &HF) '/* BBRi
IF (RAMG(MCZp())) AND (2 ^ (I \ sh4)) THEN REGINC ELSE M.JR 'BBSi

CASE ELSE
tt! = TIMER
PRINT CYCLE& / (tt! - ts!), COUNTER& / (tt! - ts!), tt! - ts!
PRINT CYCLE&, COUNTER&
PRINT
PRINT "ERROR:"; HEX$(reg.PC.w - 1), HEX$(I): ENDPROG
'default:
'  if(_TrapBadOps) {
'    fprintf
'    ( stderr,
'      "[M6502 %lX] Unrecognized instruction: $%02X at PC=$%04X\n",
'      (unsigned)_User,Op6502(REG.PC.W-1),(word)(REG.PC.W-1)
'    );
'
'    _Trace=1;
'
'  }
'
'  break;
END SELECT
IF watch = 2 THEN
watch = 1
PRINT
kk$ = INPUT$(1)
'watch = 0

END IF
NEXTCODES:
END SUB

SUB ENDPROG ()
VMMEND
END
END SUB

SUB Int6502 (a)
END SUB

FUNCTION io_read (a&)
'PRINT "io_read "; HEX$(a&); ': END
'EXIT FUNCTION
SELECT CASE a AND &H1C00
CASE &H0: PRINT "vdc"; a AND &HFF;
          SELECT CASE a AND &H3
          CASE 0
          io_read = 2 ^ 6 'vd on
            'ret = io.vdc_status
            'io.vdc_status = 0
            'io_read = ret: EXIT FUNCTION
          CASE 2, 3
            SELECT CASE io.vdc_reg
            CASE &H2: 'vrr
                   io.ddv(2).w = vramg
                  
            END SELECT

            SELECT CASE a AND &H3
            CASE 2: io_read = io.vdc(io.vdc_reg).l 'lsb
            CASE 3: io_read = io.vdc(io.vdc_reg).h 'msb
            END SELECT


CASE &H400: PRINT "vce"; a AND &HFF;
CASE &H800: PRINT "psg"; a AND &HFF;
CASE &HC00: PRINT "timer"; a AND &HFF;
CASE &H1000: PRINT "joypad"; a AND &HFF;
CASE &H1400: PRINT "irq"; a AND &HFF;
CASE &H1800: PRINT "cd-rom"; a AND &HFF;
CASE ELSE: PRINT "io_read "; HEX$(a)
K$ = INPUT$(1)
END SELECT

EXIT FUNCTION
'byte IO_read(word A)
'byte ret

  SELECT CASE a& AND &H1C00
  CASE &H0:    '/* VDC */
          SELECT CASE a& AND 3
          CASE 0:
            ret = io.vdc_status
            io.vdc_status = 0';//&=VDC_InVBlank;//&=~VDC_BSY;
            io_read = ret: EXIT FUNCTION
          CASE 1:
            io_read = 0: EXIT FUNCTION
          CASE 2:
            IF (io.vdc_reg = vrr) THEN
               io_read = vramg(word(io.vdc(marr)) * 2): EXIT FUNCTION
            ELSE
               io_read = io.vdc(io.vdc_reg).l: EXIT FUNCTION
            END IF
          CASE 3:
            IF (io.vdc_reg = vrr) THEN
               ret = vramg(word(io.vdc(marr)) * 2 + 1)
               WORDS io.vdc(marr), word(io.vdc(marr)) + io.vdc_inc
               io_read = ret: EXIT FUNCTION
             ELSE
               io_read = io.vdc(io.vdc_reg).h: EXIT FUNCTION
             END IF
          END SELECT
    

  CASE &H400: '/* VCE */
    SELECT CASE a& AND 7
    CASE 4: io_read = io.VCE(word(io.vce_reg)).l: EXIT FUNCTION
    CASE 5: io_read = io.VCE(word(io.vce_reg)).h: WORDS io.vce_reg, word(io.vce_reg) + 1: EXIT FUNCTION
    END SELECT
    
'#ifndef FINAL_RELEASE
'  case 0x0800:  /* PSG */
'    switch(A&15){
'    case 0: return io.psg_ch;
'    case 1: return io.psg_volume;
'    case 2: return io.PSG[io.psg_ch][2];
'    case 3: return io.PSG[io.psg_ch][3];
'    case 4: return io.PSG[io.psg_ch][4];
'    case 5: return io.PSG[io.psg_ch][5];
'    CASE 6:
'        {
'            //int   ofs=io.wavofs[io.psg_ch];
'            //io.wavofs[io.psg_ch]=(io.wavofs[io.psg_ch]+1)&31;
'            //return io.wave[io.psg_ch][ofs];
'            int ofs=fixtoi(snd_pos[io.psg_ch]);
'            snd_pos[io.psg_ch]=itofix((fixtoi(snd_pos[io.psg_ch])+1)&31);
'            return io.wave[io.psg_ch][ofs];
'
'        }
'    case 7: return io.PSG[io.psg_ch][7];
'    case 8: return io.psg_lfo_freq;
'    case 9: return io.psg_lfo_ctrl;
'    default: return NODATA;
'    }
'    break;
'#endif
  CASE &HC00:  ' /* timer */
    io_read = io.timer_counter: EXIT FUNCTION

  CASE &H1000:  '/* joypad */

  
    ret = io.JOY(io.joy_counter) XOR &HFF
          IF io.joy_select AND 1 THEN
            ret = ret \ sh4
          ELSE
            ret = ret AND 15: io.joy_counter = (io.joy_counter + 1) MOD 5
          END IF
            io_read = ret OR Country: EXIT FUNCTION'; /* country 0:JPN 1=US */


  CASE &H1400: ' /* IRQ */
    SELECT CASE a& AND 15
    CASE 2: io_read = io.irq_mask: EXIT FUNCTION
    CASE 3: ret = io.irq_status: io.irq_status = 0: io_read = ret: EXIT FUNCTION
    END SELECT
    

  CASE &H1800: ' /* CD-ROM extention */
    SELECT CASE a& AND 15
    CASE 3: io.backup = DISABLE: io_read = DISABLE: EXIT FUNCTION'return io.backup = disable
'//  case 0xa:
'//      if (!io.adpcm_firstread) return PCM[io.adpcm_rptr++];
'//      else {io.adpcm_firstread=FALSE; return NODATA;}
    END SELECT
    
    
  END SELECT
    io_read = NODATA


END FUNCTION

SUB io_write (a AS LONG, v)
'PRINT "io_write "; HEX$(a);
SELECT CASE a AND &H1C00
CASE &H0: PRINT "vdc"; a AND &HFF;
  SELECT CASE a AND &H3
  CASE 0: io.vdc_reg = v AND &H1F 'reg select bit 0 - 4
  CASE 1: EXIT SUB
  CASE 2, 3: 'lsb/msb data

   SELECT CASE a AND &H3
     CASE 2: io.vdc(io.vdc_reg).l = v 'lsb
             io.vdc(io.vdc_reg).w = (io.vdc(io.vdc_reg).l AND &HFF00) OR v
     CASE 3: io.vdc(io.vdc_reg).h = v 'msb
             io.vdc(io.vdc_reg).w = (io.vdc(io.vdc_reg).l AND &HFF) OR (v * sh4)
     END SELECT

     SELECT CASE io.vdc_reg
     CASE &H2 'r/w vrr/vwr    'read vram at marr/write vram at mawr
               SELECT CASE a AND &H3
               CASE 2:
               CASE 3:

     END SELECT
  
  END SELECT

CASE &H400: PRINT "vce"; a AND &HFF;
CASE &H800: PRINT "psg"; a AND &HFF;
CASE &HC00: PRINT "timer"; a AND &HFF;
CASE &H1000: PRINT "joypad"; a AND &HFF;
CASE &H1400: PRINT "irq"; a AND &HFF;
CASE &H1800: PRINT "cd-rom"; a AND &HFF;
CASE ELSE: PRINT "io_write "; HEX$(a);
K$ = INPUT$(1)

END SELECT




EXIT SUB

'A,v
  SELECT CASE a AND &H1C00
  CASE &H0:     '/* VDC */
        SELECT CASE a AND 3
        CASE 0: io.vdc_reg = v AND 31: EXIT SUB:
        CASE 1: EXIT SUB
        END SELECT
        CASE 2:
       
             SELECT CASE io.vdc_reg
             CASE vwr:
             CASE hdr:
'                        io.screen_w = (V + 1) * 8:
                        
                        

             CASE mwr:
'                        'static byte bgw[]={32,64,128,128}:
'                        'io.bg_h=(V AND &h40)?64:32:
'                        'io.bg_w=bgw[(V>>4) AND 3]:}
'
'
'
             CASE byr:
                 IF scroll = 0 THEN
                                oldScrollX = ScrollX:
                                oldScrollY = ScrollY:
                                oldScrollYDiff = ScrollYDiff:
                 END IF
                        io.vdc(byr).l = v:
                        scroll = 1:
                                ScrollYDiff = scanline - 1:
                        EXIT SUB:
        CASE bxr:
            IF scroll = 0 THEN
                                oldScrollX = ScrollX:
                                oldScrollY = ScrollY:
                                oldScrollYDiff = ScrollYDiff:
            END IF
                        io.vdc(bxr).l = v:
                        scroll = 1:
                        EXIT SUB:


        END SELECT
                io.vdc(io.vdc_reg).l = v:
                EXIT SUB:
    CASE 3:

        SELECT CASE io.vdc_reg
        CASE vwr:
                 
                        VRAMp word(io.vdc(mawr)) * 2, io.VDC_ratch:
                        VRAMp word(io.vdc(mawr)) * 2 + 1, v
                        'vchanges(io.VDC(MAWR).W / 64) = 1:
                        'io.VDC[MAWR].W+=io.vdc_inc:
                        io.VDC_ratch = 0:
                        EXIT SUB:
        CASE VDW:
                        
                        io.vdc(VDW).h = v:
                        'io.screen_h = (io.VDC(VDW).W AND 511) + 1:
                        'MaxLine = io.screen_h - 1:
                        
                        EXIT SUB:
        CASE LENR:
                        
                        io.vdc(LENR).h = v:
                        
            '/* VRAM to VRAM DMA */
            'memcpy(VRAM+io.VDC[DISTR].W*2,VRAM+io.VDC[SOUR].W*2,
            '                    (io.VDC[LENR].W+1)*2):
            '            memset(vchange+io.VDC[DISTR].W/16,1,(io.VDC[LENR].W+1)/16):
            '            memset(vchange+io.VDC[DISTR].W/64,1,(io.VDC[LENR].W+1)/64):
'                        io.VDC[DISTR].W += io.VDC[LENR].W+1:
'                        io.VDC[SOUR].W += io.VDC[LENR].W+1:
'                        io.vdc_status|=VDC_DMAfinish:
'                        EXIT SUB:
        CASE cr:
'                        static byte incsize[]={1,32,64,128}:
'                        io.vdc_inc = incsize[(V>>3) AND 3]:
                        
            

        CASE hdr:
            
            
                        
        CASE byr:
'            IF (scroll = 0) THEN
'                                oldScrollX = ScrollX:
'                                oldScrollY = ScrollY:
'                                oldScrollYDiff = ScrollYDiff:
'            END IF
'                        io.VDC(BYR).B.h = V AND 1:
'                        scroll = 1:
'                                ScrollYDiff = scanline - 1:
'
                        EXIT SUB:
        CASE SATB:
'                        io.VDC(SATB).B.h = V:
'
'
'                        io.vdc_satb = 1:
'                        io.vdc_status AND =~VDC_SATBfinish:
'                        EXIT SUB:
        CASE bxr:
'            IF (scroll = 0) THEN
'                                oldScrollX = ScrollX:
'                                oldScrollY = ScrollY:
'                                oldScrollYDiff = ScrollYDiff:
'            END IF
 '                       io.VDC(BXR).B.h = V AND 3:
'                        scroll = 1:
'                        EXIT SUB:


  '      END SELECT
                
'                io.VDC(io.vdc_reg).B.h = V:
'                EXIT SUB:
    END SELECT


  CASE &H400:   '/* VCE */
        SELECT CASE (a AND 7)
        CASE 0:
                
        CASE 2: io.vce_reg.l = v: EXIT SUB:
        CASE 3: io.vce_reg.h = v AND 1: EXIT SUB:
        CASE 4: io.VCE(word(io.vce_reg)).l = v:
'
'                 byte c: int i,n:
                 n = word(io.vce_reg)
                 c = word(io.VCE(n)) \ sh1
         IF n = 0 THEN
                FOR II = O TO 255 STEP 16: Pal(II) = c: NEXT II
'                        for(i=0:i<256:i+=16) Pal[i]=c:
         ELSE IF (n AND 15) THEN Pal(n) = c:
        END IF


                EXIT SUB:
    CASE 5:
                io.VCE(word(io.vce_reg)).h = v:
        
'                 byte c: int i,n:
                 n = word(io.vce_reg)
                 c = word(io.VCE(n)) \ sh1
        IF n = 0 THEN
        FOR II = 0 TO 255 STEP 16: Pal(II) = c: NEXT II
'                        'for(i=0:i<256:i+=16) Pal[i]=c:
             ELSE IF (n AND 15) THEN Pal(n) = c:
        END IF
                WORDS io.vce_reg, (word(io.vce_reg) + 1) AND &H1FF:
                EXIT SUB

        CASE 1:
        CASE 6:
        CASE 7:
    END SELECT
 


  CASE &HC00:   '/* timer */
        
        SELECT CASE a AND 1
        CASE 0: io.timer_reload = v AND 127: EXIT SUB:
        CASE 1:
                v = v AND 1:
                IF (v <> 0 AND io.timer_start = 0) THEN io.timer_counter = io.timer_reload:
                io.timer_start = v:
                EXIT SUB:
    END SELECT
        

  CASE &H1000: ' /* joypad */

                io.joy_select = v AND 1:
                IF (v AND 2) THEN io.joy_counter = 0:
                EXIT SUB:

  CASE &H1400:  '/* IRQ */
        SELECT CASE a AND 15
        CASE 2: io.irq_mask = v:
        CASE 3: io.irq_status = (io.irq_status AND NOT (TIRQ)) OR (v AND &HF8): EXIT SUB:
    END SELECT
        

  CASE &H1800: ' /* CD-ROM extention */
        SELECT CASE a AND 15
        CASE 7: io.backup = ENABLE: EXIT SUB:
'        CASE 8: IO.ADPCM_PTR..B.L =V:EXIT SUB
'        CASE 9: io.adpcm_ptr.B.h = V: EXIT SUB:
        'case &ha: PCM[io.adpcm_wptr++] = V: exit sub:
'        CASE &HD:
'                if (V AND 4) io.adpcm_wptr = io.adpcm_ptr.W:
'                else { io.adpcm_rptr = io.adpcm_ptr.W: io.adpcm_firstread = TRUE: }
                EXIT SUB:
'*/
   END SELECT
        
  END SELECT


END SUB

FUNCTION Joysticks ()
END FUNCTION

SUB loadpce (f%)

    fs& = LOF(f%)
    hdr& = fs& AND &H1FFF
    fsize& = fs& AND NOT (&H1FFF)


    'populus requires pop ram (&h8000) in total for  &h40 - > &h43 inc &h2000
    'find why the processor knows it uses popram?

    ROM& = allocVMM&(fs&)
   'popram& = allocvmm&(&H10000) 'byte    'fill ?
    WRAM& = allocVMM&(&H2000)    'byte
    RAM& = allocVMM&(32768)      'byte
    vram& = allocVMM&(&H10000)   'byte
    ioarea& = allocVMM&(&H2000)  'byte


    DO UNTIL ADR& > fs&     'load rom
    D$ = INPUT$(32767, f%)
    vmmP ROM& + ADR&, D$
    D$ = ""
    ADR& = ADR& + 32767
    LOOP

    lockvmm ROM&, RAM& - 1
    ROM& = ROM& + hdr&


    ROM.SIZE = fsize& \ &H2000
    rommask = 1
    

WHILE (rommask < ROM.SIZE)
    rommask = rommask * sh1
    WEND
    rommask = rommask - 1
    

    FOR I = 0 TO &HF7

    
        IF (ROM.SIZE = &H30) THEN
        
            SELECT CASE (I AND &H70)
            
            
            
            CASE &H50, &H10, &H0:
                

            
            rommap&(I) = ROM& + (I AND rommask) * 8192&
            
            CASE &H60, &H20:
                
                 

                 rommap&(I) = ROM& + ((I - &H20) AND rommask) * &H2000&
            
            CASE &H70, &H30:

                rommap&(I) = ROM& + ((I - &H10) AND rommask) * &H2000&
                
            CASE &H40:
                'rommap&(I) = rom& + ((I - &H20) AND rommask) * &h2000&

            
            rommap&(I) = ROM& + ((I - &H20) AND rommask) * &H2000&
            END SELECT
        
        ELSE


     rommap&(I) = ROM& + (I AND rommask) * &H2000&
    
       END IF
    NEXT I

    rommap&(&HF7) = WRAM&
    rommap&(&HF8) = RAM&
    rommap&(&HF9) = RAM& + &H2000
    rommap&(&HFA) = RAM& + &H4000
    rommap&(&HFB) = RAM& + &H6000
    rommap&(&HFF) = ioarea&' //NULL; /* NULL = I/O area */









END SUB

STATIC FUNCTION loop6502 ()
EXIT FUNCTION
'byte loop6502(M6502 * R)
'{
'    STATIC UCount: UCount = 0

'    STATIC ACount: ACount = 0
'    STATIC prevline
    'int dispmin, dispmax;
    'int ret
    '//printf("PC:%04x ",R->PC.W);

    IF MaxLine - MinLine > maxdisp THEN
                     dispmin = MinLine + ((MaxLine - MinLine - maxdisp + 1) \ sh1)
                     dispmax = MaxLine - ((MaxLine - MinLine - maxdisp + 1) \ sh1)
                     ELSE
                     dispmin = MinLine
                     dispmax = MaxLine
                     END IF

    'dispmin = (MaxLine-MinLine>MAXDISP ? MinLine+((MaxLine-MinLine-MAXDISP+1)>>1) : MinLine);
    'dispmax = (MaxLine-MinLine>MAXDISP ? MaxLine-((MaxLine-MinLine-MAXDISP+1)>>1) : MaxLine);

    scanline = (scanline + 1) MOD scanlines_per_frame
    '//printf("scan %d\n",scanline);
    ret = INT_NONE
    io.vdc_status = io.vdc_status AND NOT VDC_RasHit
    IF (scanline > MaxLine) THEN io.vdc_status = io.vdc_status OR VDC_InVBlank
'//  if (scanline==MinLine+scanlines_per_frame-1)
'//  else
    
    IF (scanline = MinLine) THEN
        io.vdc_status = io.vdc_status AND NOT VDC_InVBlank
        prevline = dispmin
        ScrollYDiff = 0
        oldScrollYDiff = 0
'//      if (io.vdc_iswrite_h)
'//      {
'//          io.vdc_iswrite_h = 0;
'//          ScrollY = io.VDC[BYR].W;
'//      }
'//      TRACE("\nFirstLine\n");
    ELSE
      IF (scanline = MaxLine) THEN
            IF (CheckSprites()) THEN
                 io.vdc_status = io.vdc_status OR VDC_SpHit
            ELSE io.vdc_status = io.vdc_status AND NOT VDC_SpHit
            END IF

            IF (UCount) THEN
                 UCount = UCount - 1
            ELSE
                 IF (SpriteON <> 0 AND SPONSwitch <> 0) THEN RefreshSprite prevline, dispmax, 0
                 RefreshLine prevline, dispmax - 1
                 IF (SpriteON <> 0 AND SPONSwitch <> 0) THEN RefreshSprite prevline, dispmax, 1
                 prevline = dispmax
                 UCount = UPeriod
                 RefreshScreen
            END IF

      
      END IF

    END IF





    IF (scanline >= MinLine AND scanline <= MaxLine) THEN
        IF (scanline = (word(io.vdc(rcr)) AND 1023) - 64) THEN
            IF (RasHitON <> 0 AND UCount = 0 AND dispmin <= scanline AND scanline <= dispmax) THEN
                IF (SpriteON <> 0 AND SPONSwitch <> 0) THEN RefreshSprite prevline, scanline, 0
                RefreshLine prevline, scanline - 1
                IF (SpriteON <> 0 AND SPONSwitch <> 0) THEN RefreshSprite prevline, scanline, 1
                prevline = scanline
            END IF
            io.vdc_status = io.vdc_status OR VDC_RasHit
            IF (RasHitON) THEN
                '//TRACE("rcr=%d\n", scanline);
                ret = INT_IRQ
            END IF
        ELSE
            IF (scroll) THEN
              IF (scanline - 1 > prevline AND UCount = 0) THEN
                  'int tmpScrollX, tmpScrollY, tmpScrollYDiff;
                  tmpScrollX = ScrollX
                  tmpScrollY = ScrollY
                  tmpScrollYDiff = ScrollYDiff
                  ScrollX = oldScrollX
                  ScrollY = oldScrollY
                  ScrollYDiff = oldScrollYDiff
                  IF (SpriteON <> 0 AND SPONSwitch <> 0) THEN RefreshSprite prevline, scanline - 1, 0
                  RefreshLine prevline, scanline - 2
                  IF (SpriteON <> 0 AND SPONSwitch <> 0) THEN RefreshSprite prevline, scanline - 1, 1
                  prevline = scanline - 1
                  ScrollX = tmpScrollX
                  ScrollY = tmpScrollY
                  ScrollYDiff = tmpScrollYDiff
              END IF
            END IF
        END IF
     ELSE
        'int rcr = (io.VDC[RCR].W&1023)-64;
        IF (scanline = rcr) THEN
        
'//          ScrollYDiff = scanline
            IF (RasHitON) THEN
                '//TRACE("rcr=%d\n", scanline);
                io.vdc_status = io.vdc_status OR VDC_RasHit
                ret = INT_IRQ
            END IF
        END IF
    END IF
    


    scroll = 0
    IF (scanline = MaxLine + 1) THEN
'//  if (scanline=scanlines_per_frame-63) THEN
           'int
           J = Joysticks()
           IF (J AND &H10000) THEN loop6502 = INT_QUIT: EXIT FUNCTION
           io.JOY(0) = J

        '/* VRAM to SATB DMA */
           IF (io.vdc_satb = 1 OR (io.vdc(DCR).w AND &H10) <> 0) THEN
        
              'memcpy(SPRAM,VRAM+io.VDC[SATB].W*2,64*8);
              io.vdc_satb = 1
              io.vdc_status = io.vdc_status AND NOT VDC_SATBfinish
           END IF

           IF (ret = INT_IRQ) THEN
               io.vdc_pendvsync = 1
           ELSE
              '//TRACE("vsync\n");
              '//io.vdc_status|=VDC_InVBlank;
              IF (VBlankON) THEN
                   '   //TRACE("vsync=%d\n", scanline);
                   ret = INT_IRQ
              END IF
           END IF
    
    ELSE
      IF (scanline = min(MaxLine + 5, scanlines_per_frame - 1)) THEN
          IF (io.vdc_satb) THEN
              io.vdc_status = io.vdc_status OR VDC_SATBfinish
              io.vdc_satb = 0
              IF (SATBIntON) THEN
                 '//TRACE("SATB=%d\n", scanline);
                 ret = INT_IRQ
              END IF
'/*      } else {
'            io.vdc_status&=~VDC_SATBfinish;
'            io.vdc_satb = 0;
'*/      }
         END IF
     
      ELSE
         IF (io.vdc_pendvsync <> 0 AND ret <> INT_IRQ) THEN
             io.vdc_pendvsync = 0
             '//io.vdc_status|=VDC_InVBlank;
             IF (VBlankON) THEN
                 '//TRACE("vsync=%d\n", scanline);
                 ret = INT_IRQ
             END IF
         END IF
      END IF
    END IF
    IF (ret = INT_IRQ) THEN
        IF ((io.irq_mask AND IRQ1) = 0) THEN
            io.irq_status = io.irq_status OR IRQ1
            '//if (io.vdc_status&0x20)
            '//TRACE("status=%02X\n", io.vdc_status);
            '//TRACE("irq:scan %d\n ",scanline);
            loop6502 = ret: EXIT FUNCTION
            'return ret;
        END IF
    END IF
    loop6502 = INT_NONE: EXIT FUNCTION
'}

END FUNCTION

STATIC SUB M.CMP (rg1, rg2)
  a% = rg1 - rg2
  IF a% AND &HFF00 THEN reg.p = reg.p AND cn.flag ELSE reg.p = reg.p OR c.flag
  a% = a% AND &HFF  'low byte
  reg.ZF = a%
  reg.NF = a%
END SUB

SUB M.JR ()
'op6502 is offset
I = op6502(reg.PC.w)
I = I + (I > 127) * 256
reg.PC.w = reg.PC.w + I + 1
CYCLE& = CYCLE& + 2
END SUB

SUB M.LDWORD (rg&)
rg& = op6502w&(reg.PC.w)
reg.PC.w = reg.PC.w + 2
END SUB

FUNCTION MCZp ()
MCZp = nop6502 + zp
END FUNCTION

FUNCTION MCZx ()
MCZx = nop6502 + reg.X + zp
END FUNCTION

FUNCTION MCZY ()
MCZY = nop6502 + reg.Y + zp
END FUNCTION

FUNCTION min (a, b)
END FUNCTION

FUNCTION nop6502 ()
'nop6502 = vmmGb(PAGE&(REG.PC.W \ SHD) + REG.PC.W)
a& = vmmGb(PAGE&(reg.PC.w \ SHD) + reg.PC.w)

IF watch = 2 THEN PRINT HEX$(a&); " ";

nop6502 = a&
reg.PC.w = reg.PC.w + 1
END FUNCTION

FUNCTION notb (a%)
notb = NOT (a%) AND &HFF
END FUNCTION

FUNCTION op6502 (A1&)
'a& = a1&
'IF a& < 0 THEN a& = 65536 + a&
'PRINT HEX$(a&); " ";
'op6502 = vmmGb(PAGE&(a1& \ SHD) + a1&)
a& = vmmGb(PAGE&(A1& \ SHD) + A1&)
op6502 = a&
IF watch = 2 THEN PRINT HEX$(a&); " ";
END FUNCTION

FUNCTION op6502w& (A1&)
'retrieve unsigned integer
'error h,l order?
'a1% = op6502(A&)'l
'a2% = op6502(A& + 1)'h
'OP6502W& = a1% + a2% * 2 ^ 8

a& = vmmGw(PAGE&(A1& \ SHD) + A1&)
IF a& < 0 THEN a& = a& + 65536
op6502w& = a&
IF watch = 2 THEN PRINT HEX$(a&); " ";

END FUNCTION

FUNCTION RAMG% (a&)
RAMG% = vmmGb(RAM& + a&)
END FUNCTION

FUNCTION ramGw& (a&)
a& = vmmGw(RAM& + a&)
IF a& < 0 THEN a& = 65536 + a&
ramGw& = a&
END FUNCTION

SUB ramP (a&, b%)
'PRINT "RAMP("; HEX$(A&); ")";
vmmPb RAM& + a&, b%
END SUB

FUNCTION Rd6502 (a&)
'PRINT "Rd6502("; HEX$(a&); ")";
'IF a& < 0 THEN a& = 65536 + a&
p = a& \ SHD

IF PAGE&(p) <> ioarea& THEN
ADR& = PAGE&(p) + a&
'Rd6502 = vmmGb(adr&)
A1& = vmmGb(ADR&)
Rd6502 = A1&
IF watch = 2 THEN PRINT HEX$(A1&); " ";
ELSE
Rd6502 = io_read(a&)
END IF
END FUNCTION

SUB RefreshLine (a, b)
END SUB

SUB RefreshScreen ()
END SUB

SUB RefreshSprite (a, b, c)
END SUB

SUB REGINC ()
WORDS reg.PC, reg.PC.w + 1
END SUB

SUB RESET6502 ()
  reg.MPR(7) = &H0: BANK.SET 7, &H0

   reg.MPR(6) = &H5: BANK.SET 6, &H5

   reg.MPR(5) = &H4: BANK.SET 5, &H4

   reg.MPR(4) = &H3: BANK.SET 4, &H3

   reg.MPR(3) = &H2: BANK.SET 3, &H2

   reg.MPR(2) = &H1: BANK.SET 2, &H1

   reg.MPR(1) = &HF8: BANK.SET 1, &HF8   'ram

   reg.MPR(0) = &HFF: BANK.SET 0, &HFF   'io area
  reg.a = 0: reg.X = 0: reg.Y = 0
  reg.p = I.flag

  reg.NF = 0: reg.VF = 0

  reg.ZF = &HFF
  reg.S = &HFF
  reg.PC.w = op6502w&(VEC.RESET)
  'ta.L = op6502(vec.timer)
  'ta.H = op6502(vec.timer + 1)


reg.ICOUNT = reg.IPERIOD
  reg.IREQUEST = INT.NONE
  reg.AFTERCLI = 0
  '//_CycleCount=0;
  '(int)(R->User)=0;
  reg.USER = 0
END SUB

SUB RUN6502 ()
instr.init
DIM a AS regg
RESET6502

a = reg
a.PC = ta
ts! = TIMER - .01
DO
I = nop6502
CYCLE& = CYCLE& + CYCLES(I)
CODES I


'SWAP a, reg: SWAP c&, cycle&  'needed to execute timer irq

LOOP
END SUB

STATIC FUNCTION RUN6502A& ()
' static int CycleCountOld;
' extern int TimerPeriod;
' extern int frame;
' unsigned char tmp_str[15];

'#ifdef CHRONO
'  uclock_t t0,t1;
'  unsigned char old_I;
'  extern unsigned nb_used[256],time_used[256];
'#endif
RESET6502
instr.init

 DO


    I = nop6502
    
    CYCLE = CYCLES(I)
    CYCLE& = CYCLE& + CYCLE

'    #ifdef CHRONO
'      nb_used[old_I=I]++;
'      t0=uclock();
'    #endif

   CODES I


'  #ifdef CHRONO
'  t1=uclock();
'  time_used[old_I]+=(unsigned)(t1-t0);
'  #endif


     'REG.ICOUNT = REG.ICOUNT - cycle&
     'REG.CYCLECOUNT = REG.CYCLECOUNT + cycle&

'//  *(unsigned*)&_User+=cycle;
' //       textout(screen,font,itoa(frame,tmp_str,10),0,0,1);
' //   if (frame==30)
'   //   return 0;

'    /* If cycle counter expired... */
    IF (reg.ICOUNT <= 0) THEN

      '/* If we have come after CLI, get INT_? from IRequest */
      '/* Otherwise, get it from the loop handler            */
      IF (reg.AFTERCLI) THEN


        IF (reg.IREQUEST AND INT.TIMER) THEN
             reg.IREQUEST = reg.IREQUEST AND NOT INT.TIMER
             I = INT.TIMER


        ELSE

          IF (reg.IREQUEST AND INT.IRQ) THEN
             reg.IREQUEST = reg.IREQUEST AND NOT INT_IRQ
             I = INT.IRQ
          ELSE
             IF (reg.IREQUEST AND INT.IRQ2) THEN
              reg.IREQUEST = reg.IREQUEST AND NOT INT.IRQ2
              I = INT.IRQ2
             END IF
          END IF
       END IF
       reg.ICOUNT = 0

        IF (reg.IREQUEST = 0) THEN
        reg.ICOUNT = reg.IBACKUP
        reg.AFTERCLI = 0
        END IF

    ELSE

        I = loop6502  '        /* Call the periodic handler */
        reg.ICOUNT = reg.ICOUNT + reg.IPERIOD
   END IF
      IF (I = INT.QUIT) THEN RUN6502A = reg.PC.w: EXIT FUNCTION'return(_PC_); /* Exit if INT_QUIT     */
      IF I THEN Int6502 I'              /* Interrupt if needed  */


      'if ((unsigned int)(_CycleCount-CycleCountOld) > (unsigned int)TimerPeriod*2)
      'CycleCountOld = REG.CYCLECOUNTER
      'END IF

    ELSE

        IF (reg.CYCLECOUNT - CycleCountOld >= TimerPeriod) THEN
            CycleCountOld = CycleCountOld + TimerPeriod
            I = TimerInt
            IF I THEN Int6502 I
        END IF

    END IF

  

 LOOP
  '/* Execution stopped */
  'return(_PC_);
 RUN6502A = reg.PC.w
'}

END FUNCTION

SUB T_INIT (SRC&, DIST&, LENGTH&)
'a& = word(reg.pc)
a& = reg.PC.w
SRC& = op6502w&(a&): a& = a& + 2
DIST& = op6502w&(a&): a& = a& + 2
LENGTH& = op6502w&(a&): a& = a& + 2
'WORDS REG.PC, A&
reg.PC.w = a&
'cycle = length& * 6
CYCLE& = CYCLE& + LENGTH& * 6
END SUB

FUNCTION vramg (a%)
vramg = vmmGb(vram& + a%)

END FUNCTION

SUB VRAMp (a%, b%)
vmmPb vram& + a%, b%
END SUB

SUB vrampw (a%, vv AS pcc)
vmmPb vram& + a%, vv.l
vmmPb vram& + a%, vv.h
END SUB

FUNCTION word& (rg AS pcc)
'A% = CVI(CHR$(RG.L) + CHR$(RG.H))
'WORD& = CVL(MKI$(A%) + MKI$(0))

word& = rg.l + rg.h * SH8

'word& = CVL(CHR$(RG.l) + CHR$(RG.h) + MKI$(0))



END FUNCTION

SUB WORDS (rg AS pcc, A1&)
a& = A1&
IF a& < 0 THEN a& = 65536 + a&
a& = a& AND &HFFFF
rg.l = a& AND &HFF
rg.h = a& \ SH8
rg.w = a&
END SUB

SUB Wr6502 (a&, v)
'PRINT "Wr6502("; HEX$(a&); ")";
p = a& \ SHD
IF PAGE&(p) <> ioarea& THEN
vmmPb PAGE&(p) + a&, v
ELSE
io_write a&, v
END IF
END SUB

