DECLARE SUB mfl (rg%)
DECLARE FUNCTION TimerInt% ()
DECLARE FUNCTION RUN6502A& ()
DECLARE SUB Int6502 (A%)
DECLARE FUNCTION loop6502% ()
DECLARE FUNCTION CheckSprites% ()
DECLARE SUB RefreshSprite (A%, b%, c%)
DECLARE SUB RefreshLine (A%, b%)
DECLARE SUB RefreshScreen ()
DECLARE FUNCTION Joysticks% ()
DECLARE FUNCTION min% (A%, b%)
DECLARE FUNCTION ramGw& (A&)
DECLARE FUNCTION nop6502% ()
DECLARE SUB REGINC ()
DECLARE FUNCTION opcode$ (I%)
DECLARE SUB BANK.SET (P%, V%)
DECLARE SUB cmdc (cmd%, rg AS ANY)
DECLARE SUB cmdd (CMD1%, CMD2%)
DECLARE SUB cmdr (cmd%, rg%)
DECLARE SUB CODES (I%)
DECLARE SUB endprog ()
DECLARE FUNCTION io_read% (A&)
DECLARE SUB io_write (A AS LONG, V%)
DECLARE SUB loadpce (f%)
DECLARE SUB M.CMP (rg1%, rg2%)
DECLARE SUB M.JR ()
DECLARE SUB M.LDWORD (rg AS ANY)
DECLARE FUNCTION MCZp% ()
DECLARE FUNCTION MCZx% ()
DECLARE FUNCTION MCZY% ()
DECLARE FUNCTION notb% (A%)
DECLARE FUNCTION op6502% (A1&)
DECLARE FUNCTION op6502w& (A&)
DECLARE FUNCTION RAMG% (A&)
DECLARE SUB RAMp (A&, b%)
DECLARE FUNCTION Rd6502% (A&)
DECLARE SUB RESET6502 ()
DECLARE SUB RUN6502 ()
DECLARE SUB T_INIT (src&, dist&, LENGTH&)
DECLARE FUNCTION vramg% (A&)
DECLARE SUB vramp (A&, b%)
DECLARE FUNCTION word& (rg AS ANY)
DECLARE SUB words (rg AS ANY, A1&)
DECLARE SUB Wr6502 (A&, V%)
DECLARE SUB instr.init ()
DECLARE SUB INITVMM (SIZE%)
DECLARE SUB lockvmm (A&, b&)
DECLARE SUB VMMEND ()
DECLARE SUB vmmP (ADR&, D$)
DECLARE SUB vmmPb (ADR&, b%)
DECLARE FUNCTION allocVMM& (SIZE&)
DECLARE FUNCTION vmmGb% (ADR&)
DECLARE FUNCTION vmmGw% (ADR&)

DEFINT A-Z




'TYPE bb  'change this around for lsb fists, last
'L AS INTEGER
'H AS INTEGER
'END TYPE


'TYPE PCC
' W AS INTEGER
' B AS bb
'END TYPE

TYPE pcc
 l AS INTEGER
 h AS INTEGER
 w AS LONG
END TYPE

TYPE regg
 P AS INTEGER        'one byte register
 A AS INTEGER        '
 X AS INTEGER        '
 Y AS INTEGER        '
 s AS INTEGER        '
 pc AS pcc           'word
 NF AS INTEGER 'one byte flag (last set)
 VF AS INTEGER '
 ZF AS INTEGER '
 'cf as integer
 'df as integer


 MPR(7) AS INTEGER   'memory mapping registers pagr<->mmap (byte)
 irequest AS INTEGER 'byte
 AfterCLI AS INTEGER 'byte
 IBACKUP AS INTEGER   'int
 iperiod AS INTEGER 'int number of cycles to loop6502
 icount AS LONG  'int
 USER AS INTEGER      'VOID    'void *user
 CYCLECOUNT AS LONG  'cyclecount = (int)user
END TYPE

TYPE ioo
 'VDC
   vdc(32) AS pcc              'pair   'VDC REGISTERS
   VDC_REG AS INTEGER          'byte   'VDC REGISTER SELECT
   vdc_status AS INTEGER       'BYTE   'VDC STATUS
   VDC_ratch AS INTEGER        'BYTE
   vdc_inc AS LONG             'word   'VDC INC +1, 32, 64, 128
   vdc_raster_count AS LONG
   vdc_satb AS INTEGER
   vdc_pendvsync AS INTEGER

   VDC_SCD AS INTEGER
   VDC_SND AS INTEGER
   VDC_RSR AS INTEGER
   VDC_IRQ AS INTEGER
   VDC_SPRITES AS INTEGER
   VDC_BACKGROUND AS INTEGER


 VCE(&H200) AS pcc
 vce_reg AS pcc
 'vdc
 vce_ratch AS INTEGER
 bg_h AS INTEGER             'integer
 bg_w AS INTEGER
 screen_w AS INTEGER
 screen_h AS INTEGER
 screen_x AS INTEGER
 scroll_y AS INTEGER
 minline AS INTEGER
 maxline AS INTEGER
 'joypad
 JOY(16) AS INTEGER          'byte
 JOY_SELECT AS INTEGER
 JOY_COUNTER AS INTEGER
 'psg
  psg(6, 8) AS INTEGER
  wave(6, 32) AS INTEGER
  wavofs(6) AS INTEGER

  '// PSG STRUCTURE
  '// 0 : dda_out
  '// 2 : freq (lo byte)  In reality it's a divisor
  '// 3 : freq (hi byte)
  '// 4 : dda_ctrl
  '//     000XXXXX
  '//     ^^  ^
  '//     ||  ch. vol
  '//     ||
  '//     |direct access (everything at byte 0)
  '//     |
  '//    enable
  '// 5 : pan (left vol = hi nibble, right vol = low nibble)
  '// 7 : noise_ctrl
  psg_ch AS INTEGER         'byte
  psg_volume AS INTEGER
  psg_lfo_freq AS INTEGER
  psg_lfo_ctrl AS INTEGER
  '/* TIMER */
  timer_reload AS INTEGER  'byte
  timer_start AS INTEGER
  timer_counter AS INTEGER
  '/* IRQ */
    irq_mask AS INTEGER    'byte
    irq_status AS INTEGER
  '/* CDROM extention */
   backup AS INTEGER          'integer
   adpcm_firstread AS INTEGER 'integer
   adpcm AS pcc               'pair
   adpcm_rptr AS LONG         'word
   adpcm_wptr AS LONG
 END TYPE





'byte = unsigned char (1)
'word = unsigned short (2)
'offset = signed char

'UNION pair
' word w
' int b {byte l,h}
'end type
' n
' n.w
' n.b (n.b.l,n.b.h)


                       '       /* 6502 status flags:         */
CONST c.flag = &H1     '       /* 1: Carry occured           */
                       '       /* notb c.flag
CONST z.flag = &H2     '       /* 1: Result is zero          */
CONST I.FLAG = &H4     '       /* 1: Interrupts disabled     */
CONST D.flag = &H8     '       /* 1: Decimal mode            */
CONST b.flag = &H10    '       /* Break [0 on stk after int] */
CONST T.FLAG = &H20    '       /* Memory Operation Flag      */
CONST V.FLAG = &H40    '       /* 1: Overflow occured        */
CONST N.FLAG = &H80    '       /* 1: Result is negative      */

CONST nvzN.flag = NOT (z.flag OR N.FLAG OR V.FLAG) AND &HFF
CONST cn.flag = NOT c.flag AND &HFF
CONST Dn.FLAG = NOT D.flag AND &HFF
CONST IN.FLAG = NOT I.FLAG AND &HFF
CONST Tn.flag = NOT T.FLAG AND &HFF



CONST byt = &HFF       '       /* byte
CONST wrd = &HFFFF&    '       /* word

CONST sh1 = &H2    'LSHIFT / RSHIFT FUNCTIONS
CONST SH2 = &H4
CONST SH3 = &H8
CONST SH4 = &H10
CONST SH5 = &H20
CONST SH6 = &H40
CONST SH7 = &H80
CONST SH8 = &H100&
CONST SH9 = &H200
CONST SHA = &H400
CONST SHB = &H800
CONST SHC = &H1000
CONST SHD = &H2000
CONST SHE = &H4000
CONST SHF = &H8000

'                      '       /* Loop6502() returns:        */
CONST int.none = 0     '       /* No interrupt required      */
CONST INT.IRQ = 1      '       /* Standard IRQ interrupt     */
CONST INT.NMI = 2      '       /* Non-maskable interrupt     */
CONST INT.QUIT = 3     '       /* Exit the emulation         */

CONST IRQ1 = 1
CONST IRQ2 = 2
CONST tirq = 4


CONST INT.TIMER = 4
CONST INT.IRQ2 = 8
CONST VEC.RESET = &HFFFE&
CONST VER.NMI = &HFFFC&
CONST VEC.TIMER = &HFFFA&
CONST VEC.IRQ = &HFFF8&
CONST VER.IRQ2 = &HFFF6&
CONST VEC.BRK = &HFFFE&
CONST zp = 0              'stack page
CONST sp = &H100          'zero page

CONST maxdisp = 227
CONST scanlines_per_frame = 263
CONST baseclock = 7800000!
CONST timerperiod = baseclock / 1000 * 3 * 1024 / 21480
CONST iperiod = baseclock / (scanlines_per_frame * 60)


'vdc registers
CONST vdc_mawr = 0, vdc_marr = 1, vdc_vrr = 2, VDC_VWR = 2, vdc_cr = 5, VDC_rcr = 6, vdc_bxr = 7, vdc_byr = 8, vdc_mwr = 9, vdc_hsr = 10
CONST vdc_hdr = 11, vdc_vpr = 12, vdc_VDW = 13, vdc_vcr = 14, vdc_dcr = 15, vdc_sour = 16, vdc_desr = 17, vdc_lenr = 18, vdc_satb = 19

CONST vdcc_cr = &H1              'also precalculate not versions of these:
CONST vdcc_or = &H2
CONST vdcc_rr = &H4
CONST vdcc_ds = &H8
CONST vdcc_dv = &H10
CONST vdcc_vd = &H20
CONST vdrc_bsy = &H40
CONST vdc_SpHit = vdcc_cr
CONST vdc_Over = vdcc_or
CONST vdc_RasHit = vdcc_rr
CONST vdc_InVBlank = vdcc_vd
CONST vdc_DMAfinish = vdcc_dv
CONST vdc_SATBfinish = vdcc_ds


DIM SHARED scroll
DIM SHARED scanline
DIM SHARED maxline, minline
DIM SHARED sphiton, overon, rashiton, vblankon, spriteon, screenon



DIM SHARED REG AS regg, cycleS%(255), I, LASTSTR, II
'DIM SHARED K AS PCC, J AS PCC
DIM SHARED cycle AS LONG, cycleS&, PAGE&(7), rommap&(255), vram&, RAM&, ioarea&, io AS ioo, ROM&
DIM SHARED ta AS pcc, COUNTER&, ts!, Pal(512)
DIM SHARED JUMPSTA(255) AS pcc, JS, JSS, JUMPSTAA(255), watch
DIM SHARED CMDSET1(255), CMDSET2(255), CMD1(255), CMD2(255), CMR1(255), CMR2(255), CMDf1(255)
'WHAT ROM TO OPEN?
'CONST FILE1 = "neutop1.pce", FILE2 = "bonk3.pce", FILE3 = "BOMB94.PCE", file4 = "WONDRBOY.PCE", FILE5 = "SF2.PCE"
CONST file6 = "jamanoid.pce"
c$ = COMMAND$
c$ = file6
CLS
IF c$ = "" OR INSTR(c$, "/?") THEN
 PRINT "SHu99 Debugger (c)1999 smInc Filmation"
 PRINT "An SMI-Wolf Production"
 PRINT "version 99.07a-2.11_1.1"
 PRINT
 PRINT "syntax is: SHu99[v].exe [pce file]"
 PRINT "                [v]        use vmm not xms"
 PRINT "                [pre file] open this pce file"
 END
END IF
PRINT "hu99[v] init:"
'watch = 1'turn on debug mode

ON ERROR GOTO errorhndlr

OPEN c$ FOR INPUT AS #1
CLOSE #1
OPEN c$ FOR BINARY ACCESS READ AS #1
PRINT "pcefile=" + c$
PRINT "pcehandle=#1(" + HEX$(FILEATTR(1, 2)) + ")"
PRINT "pcesize=&h" + HEX$(LOF(1) * 8 / 1024) + "Kb"
'used to test with hugo core
'OPEN "c:\djgpp\bin\bob" FOR INPUT AS #5
'
'CLS
INITVMM 2048 * 4
loadpce 1

PRINT "riscdata init:"

RESTORE cycledata: FOR II = 0 TO 255: READ cycleS%(II): NEXT II
RESTORE CMDDSETDATA: FOR II = 0 TO 255: READ CMDSET1(II), CMDSET2(II): NEXT II
RESTORE CMDDDATA: FOR II = 0 TO 255: READ CMD1(II), CMD2(II): NEXT II
RESTORE CMDrDATA: FOR II = 0 TO 255: READ CMR1(II), CMR2(II): NEXT II

'SHU WIN98   DOSQEMM
'vmm 92khz   74KHZ       'on a AMD k6-]|[ 450 running win98 v86
'xvmm 193khz 257KHZ      '10SECOND TIMER

'CLS
 ON TIMER(10) GOSUB tt
 TIMER ON
 s! = TIMER
'PRINT "pcestart:"
 PRINT RUN6502A
tt:
 PRINT cycleS& / (TIMER - s!), cycleS&

endprog



cycledata:
'static byte Cycles[256] =
DATA     8,7,3, 4,6,4,6,7,3,2,2,0,7,5,7,6
DATA     2,7,7, 4,6,4,6,7,2,5,2,0,7,5,7,6
DATA     7,7,3, 4,4,4,6,7,3,2,2,0,5,5,7,6
DATA     2,7,7, 0,4,4,6,7,2,5,2,0,5,5,7,6
DATA     7,7,3, 4,8,4,6,7,3,2,2,0,4,5,7,6
DATA     2,7,7, 5,0,4,6,7,2,5,3,0,0,5,7,6
DATA     7,7,2, 0,4,4,6,7,3,2,2,0,7,5,7,6
DATA     2,7,7,17,4,4,6,7,2,5,3,0,7,5,7,6
DATA     4,7,2, 7,4,4,4,7,2,2,2,0,5,5,5,6
DATA     2,7,7, 8,4,4,4,7,2,5,2,0,5,5,5,6
DATA     2,7,2, 7,4,4,4,7,2,2,2,0,5,5,5,6
DATA     2,7,7, 8,4,4,4,7,2,5,2,0,5,5,5,6
DATA     2,7,2,17,4,4,6,7,2,2,2,0,5,5,7,6
DATA     2,7,7,17,0,4,6,7,2,5,3,0,0,5,7,6
DATA     2,7,0,17,4,4,6,7,2,2,2,0,5,5,7,6
DATA     2,7,7,17,2,4,6,7,2,5,3,0,0,5,7,0
 

CONST M.NUL = 0, m.inc = 1, M.DEC = 2, M.ROR = 3, M.ROL = 4, M.LSR = 5, m.asl = 6, TRB = 7, TSB = 8
CONST m.adc = 9, m.and = 10, m.andx = 11, m.bit = 12, m.eor = 13, m.eorx = 14
CONST m.fl = 15, m.ora = 16, m.orax = 17, m.pop = 18, m.push = 19, M.RMB = 20
CONST mm.zx = 21, MM.Zp = 22, mm.ax = 23, MM.Ab = 24
CONST mr.ab = 25, mr.ax = 26, mr.ay = 27, mr.id = 28, mr.im = 29, mr.ix = 30, mr.iy = 31, mr.zp = 32, mr.zx = 33, mr.zy = 34
CONST mw.ab = 35, mw.ax = 36, mw.ay = 37, mw.ix = 38, mw.iy = 39, mw.zp = 40, mw.zx = 41, mw.zy = 42
CONST m.sbc = 43
CONST M.SMB = 44
CONST m.adcx = 45
CONST mc.ab = 46, mc.ax = 47, mc.ay = 48, mc.id = 49, mc.ix = 50, mc.iy = 51, mc.zp = 52, mc.zx = 53, mc.zy = 54
CONST m.pop.p = 55, m.push.p = 56
'148KHZ with DEBUG OFF
'152KHZ with CMDDSETDATA
'195KHZ with (cmdr, cmdd) data
'289KHZ with LS, RS VALUES DEFINED AS CONST NOT 2 ^ B AT RUNTIME
'306khz compact code (nullerror lib) + runtime modual
'403KHZ converted some PCC statements
'416khz eleminated more PCC statements
'422KHZ ELIMINATED MORE PCC STATEMENTS ONLY REG.PC REMAINS
'25MHZ MAX SPEED (LONG INC)


'SPEED HINTS:  -DEFINE ALL CALCULATIOS THAT HAVE EXPECTED RESULTS AS CONSTS
'              -ELEMINATE WORD[S] (PCC statements)
'              -MAKE MORE DATA TABLES
'              -SIMPLIFY CODE (BEST ALTERNATIVE)




CMDDSETDATA: 'SET(F4) COMMANDS(0-FF):CMDD CMD1,CMD2  00,00 = NULL
DATA ,,30,17,,,,,,,32,17,,,,,,,29,17,,,,,,,25,17,,,,,,,31,17,28,17,,,,,33,17
DATA ,,,,,,27,17,,,,,,,26,17,,,,,,,30,11,,,,,,,32,11,,,,,,,29,11,,,,,,,25,11
DATA ,,,,,,31,11,28,11,,,,,33,11,,,,,,,27,11,,,,,,,26,11,,,,,,,30,14,,,,,,
DATA 32,14,,,,,,,29,14,,,,,,,25,14,,,,,,,31,14,28,14,,,,,33,14,,,,,,,27,14
DATA ,,,,,,26,14,,,,,,,30,45,,,,,,,32,45,,,,,,,29,45,,,,,,,25,45,,,,,,,31,45
DATA 28,45,,,,,33,45,,,,,,,27,45,,,,,,,26,45,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,
DATA ,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,
DATA ,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,
DATA ,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,
DATA ,,,,,,,,,,,,,,,,,,,

CMDDDATA:
DATA ,,30,16,,,,,,,32,16,,,,,,,29,16,,,,,,,25,16,,,,,,,31,16,28,16,,,,,33,16
DATA ,,,,,,27,16,,,,,,,26,16,,,,,,,30,10,,,,,32,12,32,10,,,,,,,29,10,,,,,25,12
DATA 25,10,,,,,,,31,10,28,10,,,33,12,33,10,,,,,,,27,10,,,,,26,12,26,10,,,,
DATA ,,30,13,,,,,,,32,13,,,,,,,29,13,,,,,,,25,13,,,,,,,31,13,28,13,,,,,33,13
DATA ,,,,,,27,13,,,,,,,26,13,,,,,,,30,9,,,,,,,32,9,,,,,,,29,9,,,,,,,25,9,,
DATA ,,,,31,9,28,9,,,,,33,9,,,,,,,27,9,,,,,,,26,9,,,,,,,,,,,,,,,,,,,,,,,29,12
DATA ,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,
DATA ,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,
DATA ,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,30,43,,,,,,,32,43,,,,,,,29,43,,,,,,
DATA 25,43,,,,,,,31,43,28,43,,,,,33,43,,,,,,,27,43,,,,,,,26,43,,,,

CMDrDATA:
DATA ,,,,,,,,22,8,,,22,6,20,1,,,,,,,,,24,8,,,24,6,,,,,,,,,,,22,7,,,21,6,20,2
DATA ,,,,,,,,24,7,,,23,6,,,,,,,,,,,,,,,22,4,20,4,,,,,,,,,,,,,24,4,,,,,,,,
DATA ,,,,,,21,4,20,8,,,,,,,,,,,,,23,4,,,,,,,,,,,,,,,22,5,20,16,,,,,,,,,,,,
DATA 24,5,,,,,,,,,,,,,,,21,5,20,32,,,,,,,,,,,,,23,5,,,,,,,,,,,40,,,,22,3,20,64
DATA ,,,,,,,,,,,,24,3,,,,,,,,,,,41,,,,21,3,20,128,,,,,,,,,,,,,23,3,,,,,,,,
DATA ,,,,,,,,44,1,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,44,2,,,,,,,,,35,,,,36,,,,,
DATA ,,,,,,,,,,,,44,4,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,44,8,,,,,,,,,,,,,,,,,,
DATA ,,,,,,,,,,22,2,44,16,,,,,,,,,,,,,24,2,,,,,,,,,,,,,,,21,2,44,32,,,,,,
DATA ,,,,,,23,2,,,,,,,,,,,,,,,22,1,44,64,,,,,,,,,,,,,24,1,,,,,,,,,,,,,,,21,1
DATA 44,128,,,,,,,,,,,,,23,1,,

CMDfDATA: 'first cmdr or cmdc executed by an funvtion 0 - ff
DATA ,,,,,,,,56,,6,,,,,,,,,,,,,,,,1,,,,,,,,,,,,,,55,,4,,,,,,,,,,,,,,,,2,,
DATA ,,,,,,,,,,,19,,5,,,,,,,,,,,,,,,,19,,,,,,,,,,,,,,18,,3,,,,,,,,,,,,,,,
DATA 18,,,,,,,38,,,40,40,40,,15,,15,,35,35,35,,,39,49,25,41,41,42,,15,37,
DATA ,,36,,,29,30,29,,32,32,32,,15,29,15,,25,25,25,,,31,28,26,33,33,34,,,27
DATA 15,,26,26,27,,29,30,,,32,32,,,15,29,15,,25,25,,,,31,28,,,33,,,,27,19

errorhndlr:
IF ERR THEN PRINT "a error occured in SHu99 at line"; ERL; " error #"; HEX$(ERR): RESUME
endprog

SUB BANK.SET (P, V)

IF rommap&(V) = ioarea& THEN
PAGE&(P) = ioarea&
ELSE
PAGE&(P) = rommap&(V) - P * 8192&


END IF
END SUB

FUNCTION CheckSprites ()
END FUNCTION

SUB cmdc (cmd, rg&)
SELECT CASE cmd
CASE 0: PRINT "error cmdc": endprog

CASE mc.ab
   M.LDWORD rg&
CASE mc.ax
   M.LDWORD rg&
   rg& = rg& + REG.X
CASE mc.ay
   M.LDWORD rg&
   rg& = rg& + REG.Y
CASE mc.id    '''''WORD RAM READ
  rg& = MCZp()
  'rg.L = RAMG((A%))
  'rg.H = RAMG(A% + 1)
  'rg& = word(rg)
  rg& = ramGw(rg&)

CASE mc.ix      'WORD RAM READ
  rg& = MCZx()
  'rg.L = RAMG((A%))
  'rg.H = RAMG((A%))
 'rg.w = word(rg)
  rg& = ramGw(rg&)
CASE mc.iy
  rg& = MCZp()    'WORD RAM REED
  'rg.L = RAMG((A%)): rg.H = RAMG(A% + 1)
  'WORDS rg, word(rg) + reg.y
  rg& = ramGw(rg&) + REG.Y
CASE mc.zp
  'RG.L = nop6502     'since zp=0  h:l -> 0:l
  'RG.H = zp \ SH8
  'RG.W = word(RG)

   rg& = nop6502
CASE mc.zx
  'RG.L = nop6502 + ReG.X
  'RG.H = zp \ SH8
  'RG.W = word(RG)
   rg& = nop6502 + REG.X
CASE mc.zy
  'rg.L = nop6502 + reg.Y
  'rg.H = zp \ SH8
  'rg.w = word(rg)
   rg& = nop6502 + REG.Y
CASE ELSE
  PRINT "Invalid CmdC"; cmd: endprog
END SELECT


END SUB

SUB cmdcf (rg)
cmdr CMDf1(I), rg
END SUB

SUB cmdd (CMD1, CMD2)
cmdr CMD1, I
cmdr CMD2, I
END SUB

STATIC SUB cmdr (cmd, rg)

SELECT CASE cmd
CASE M.NUL:
PRINT "error: CmdRg Null "; HEX$(LASTSTR): endprog
CASE m.adc 'm.adc 'NOTE: NOT (K AS PCC DEPENDENT)

  IF (REG.P AND D.flag) THEN 'decimal mode (#a + rg + cf ) -> (cf:#a)


  K.L = (REG.A AND &HF) + (rg AND &HF) + (REG.P AND c.flag)
  K.H = (REG.A \ SH4) + (rg \ SH4)
    IF (K.L > 9) THEN K.L = K.L + 6: K.H = K.H + 1
    IF (K.H > 9) THEN K.H = K.H + 6
    REG.A = ((K.L AND &HF) OR (K.H * SH4)) AND &HFF

    IF K.H > 15 THEN REG.P = REG.P OR c.flag ELSE REG.P = REG.P AND cn.flag
    
    
    'ZF = NF = A
    REG.ZF = REG.A
    REG.NF = REG.A
                cycle = cycle + 1

  ELSE 'hex mode (#a + rg + cf ) -> (cf:#a)

    A% = REG.A + rg + (REG.P AND c.flag)
    IF A% AND &HFF00 THEN REG.P = REG.P OR c.flag:  ELSE REG.P = REG.P AND cn.flag
    A% = A% AND &HFF
    REG.VF = (notb(REG.A XOR rg) AND (REG.A XOR A%)) \ sh1
    REG.ZF = A%
    REG.NF = A%
    REG.A = A%
   END IF
CASE m.adcx  'NOTE: NOT (K AS PCC DEPENDENT)
 'MX = AdrRAM(reg.X + ZP)
  MX = RAMG(REG.X + zp)
  IF (REG.P AND D.flag) THEN

    K.L = (MX AND &HF) + (rg AND &HF) + (REG.P AND c.flag)
    K.H = (MX \ SH4) + (rg \ SH4)';/*+(K.l>>4);*/ \
    IF (K.L > 9) THEN K.L = K.L + 6: K.H = K.H + 1
    IF (K.H > 9) THEN K.H = K.H + 6
    MX = ((K.L AND &HF) OR (K.H * SH4)) AND &HFF

    IF K.H > 15 THEN REG.P = REG.P OR c.flag ELSE REG.P = REG.P AND cn.flag
    'ZF = NF = A
    REG.ZF = MX
    REG.NF = MX


    cycle = cycle + 1

  ELSE

    A% = MX + rg + (REG.P AND c.flag)
    
    IF A% AND &HFF00 THEN REG.P = REG.P OR c.flag ELSE REG.P = REG.P AND cn.flag
    A% = A% AND &HFF
    REG.VF = (notb(MX XOR rg) AND (MX XOR A%)) \ sh1
    REG.ZF = A%
    REG.NF = A%

    MX = A%

 END IF
 'AdrRAM(reg.X + ZP) = MX
  RAMp REG.X + zp, MX

CASE m.and
  REG.A = REG.A AND rg
  mfl REG.A
CASE m.andx
   'AdrRAM(reg.x + zp) = AdrRAM(reg.x + zp) AND RG
   RAMp REG.X + zp, RAMG(REG.X + zp) AND rg
   mfl RAMG(REG.X + zp)

CASE m.asl
   REG.P = REG.P AND cn.flag
   REG.P = REG.P OR rg \ SH7
   rg = (rg * sh1) AND &HFF
   mfl rg

CASE m.bit
  REG.NF = rg
  REG.VF = rg
  REG.ZF = rg AND REG.A
CASE m.inc
  rg = rg + 1
  mfl rg

CASE M.DEC
  rg = rg - 1
  mfl rg


CASE M.ROR
  A% = (rg \ sh1) OR (REG.P * SH7)
  REG.P = REG.P AND cn.flag
  REG.P = REG.P OR (rg AND c.flag)
  'rg = A%     'to fix possible overflow
  mfl A%
  rg = A%
CASE M.ROL
  A% = (rg * sh1) OR (REG.P AND c.flag)
  REG.P = REG.P AND cn.flag
  REG.P = REG.P OR (rg \ SH7)
  'rg = A% to fix possible overflow
  mfl A%
  rg = A%
CASE M.LSR
  REG.P = REG.P AND cn.flag
  REG.P = REG.P OR (rg AND c.flag)
  rg = rg \ sh1
  mfl rg

CASE TRB

  'NF=VF=RG
  REG.NF = rg
  REG.VF = rg
  rg = rg AND notb(REG.A)
  REG.ZF = rg

CASE TSB:
  'NF=VF=RG
  REG.NF = rg
  REG.VF = rg
  rg = rg OR REG.A
  REG.ZF = rg
CASE m.eor
  REG.A = REG.A XOR rg
  mfl REG.A
CASE m.eorx
  'AdrRAM(reg.x + zp) = AdrRAM(reg.x + zp) XOR RG
  RAMp REG.X + zp, RAMG(REG.X + zp) XOR rg
  mfl RAMG(REG.X + zp)
CASE m.fl
  'ZF=NF=RG


  rg = rg AND &HFF  'flow control if needed 0 -> ff -> 0
  REG.ZF = rg
  REG.NF = rg
CASE m.ora
  REG.A = REG.A OR rg
  mfl REG.A
CASE m.orax
  'AdrRAM(reg.x + zp) = AdrRAM(reg.x + zp) OR RG
  RAMp REG.X + zp, RAMG(REG.X + zp) OR rg
  mfl RAMG(REG.X + zp)
CASE m.pop
  REG.s = (REG.s + 1) AND &HFF      'does this fix overflow
  rg = RAMG(sp + REG.s)
CASE m.push
  RAMp sp + REG.s, rg
  REG.s = (REG.s - 1) AND &HFF      'does this fix overflow
CASE m.pop.p
cmdr m.pop, rg
REG.NF = rg
REG.VF = rg
IF rg AND z.flag THEN REG.ZF = 0 ELSE REG.ZF = 1
CASE m.push.p

IF REG.ZF THEN tmp = 0 ELSE tmp = z.flag
cmdr m.push, ((rg) AND nvzN.flag) OR (REG.NF AND N.FLAG) OR (REG.VF AND V.FLAG) OR tmp

CASE M.RMB
  'AdrRAM(MCZp()) = AdrRAM(MCZp()) AND NOT (N)
  RAMp MCZp(), RAMG(MCZp()) AND notb(rg)
CASE m.sbc 'NOTE: NOT (K AS PCC) DEPENDENT
  '/* Warning! C_FLAG is inverted before SBC and after it */
    IF (REG.P AND D.flag) THEN

      K.L = ((REG.A AND &HF) - (rg AND &HF) - (notb(REG.P) AND c.flag)) AND &HFF
      IF (K.L AND &H10) THEN K.L = K.L - 6
      K.H = ((REG.A \ SH4) - (rg \ SH4) + ((K.L AND &H10) = &H10)) AND &HFF
      IF (K.H AND &H10) THEN K.H = K.H - 6
      REG.A = (K.L AND &HF) OR (K.H * SH4) AND &HFF

      IF K.H AND &H10 THEN REG.P = REG.P AND cn.flag ELSE REG.P = REG.P OR c.flag

                  cycle = cycle + 1

    ELSE

      A% = REG.A - rg - (notb(REG.P) AND c.flag)
      IF A% AND &HFF00 THEN REG.P = REG.P AND cn.flag ELSE REG.P = REG.P OR c.flag
      REG.VF = ((REG.A XOR rg) AND (REG.A XOR A%)) \ sh1
      REG.ZF = A%
      REG.NF = A%
      REG.A = A% AND &HFF
    END IF
CASE M.SMB
  'AdrRAM(MCZp()) = AdrRAM(MCZp()) OR N
  RAMp MCZp(), RAMG(MCZp()) OR rg
CASE MM.Ab
  'cmdc mc.ab, A&
  M.LDWORD A& 'GET MEMORY LOCATION
  I = Rd6502(A&)
  cmdr rg, I
  Wr6502 A&, I
CASE mm.ax
  cmdc mc.ax, A&
  I = Rd6502(A&)
  cmdr rg, I
  Wr6502 A&, I
CASE MM.Zp
  A& = MCZp()
  I = RAMG(A&)
  cmdr rg, I
  RAMp A&, I
CASE mm.zx
  A& = MCZx()
  I = RAMG(A&)
  cmdr rg, I
  RAMp A&, I
CASE mr.ab: M.LDWORD A&
            rg = Rd6502(A&)
CASE mr.ax: M.LDWORD A&
            rg = Rd6502(A& + REG.X)
CASE mr.ay: M.LDWORD A&
            rg = Rd6502(A& + REG.Y)
CASE mr.id: rg = Rd6502(ramGw(MCZp()))
CASE mr.im: rg = nop6502
CASE mr.ix: rg = Rd6502(ramGw(MCZx()))
CASE mr.iy: rg = Rd6502(ramGw(MCZp()) + REG.Y)
CASE mr.zp: rg = RAMG(MCZp())
CASE mr.zx: rg = RAMG(MCZx())
CASE mr.zy: rg = RAMG(MCZY())
CASE mw.ab: M.LDWORD A&
            Wr6502 A&, rg
CASE mw.ax: M.LDWORD A&
            Wr6502 A& + REG.X, rg
CASE mw.ay: M.LDWORD A&
            Wr6502 A& + REG.Y, rg
CASE mw.ix: Wr6502 ramGw(MCZx()), rg
CASE mw.iy: Wr6502 ramGw(MCZp()) + REG.Y, rg
CASE mw.zp: RAMp MCZp(), rg
CASE mw.zx: RAMp MCZx(), rg
CASE mw.zy: RAMp MCZY(), rg
CASE ELSE
PRINT "error: CmdRg not found(" + HEX$(cmd) + ")": endprog
END SELECT
IF (rg AND byt) <> rg THEN PRINT "Error:byte overflow"; rg: endprog



END SUB

SUB cmdrf (A)
cmdr CMDf1(I), A

END SUB

STATIC SUB CODES (I)
COUNTER& = COUNTER& + 1
LASTSTR = I

'used to test with hugo core
' LINE INPUT #5, FF$
' FF$ = UCASE$(FF$)



'keyboard trap esk
'K$ = INKEY$
'PRINT reg.pc.w
IF K$ <> "" THEN kk$ = K$
SELECT CASE LCASE$(kk$)
 CASE CHR$(27): IF watch THEN watch = 0 ELSE watch = 1
 CASE "q": endprog: END
 CASE "g": watch = 0
 CASE "s": watch = 1
 CASE "?", "h"'help
 CASE "m" 'memory map
 CASE "r" 'register value
 CASE "v" 'vram dump
   FOR iiii& = 0 TO 20
    PRINT HEX$(vramg(iiii&)); HEX$(vramg(iiii& + 1)),
   NEXT iiii&
   PRINT
 CASE "d" 'memory dump
 CASE "i" 'ints on/off
END SELECT
 kk$ = ""


'watch = 1

'IF REG.PC.W - 1 = &HD509& THEN WATCH = -1
'IF COUNTER& = &H28990 THEN WATCH = 1
IF watch = 1 THEN
'WW = RAMG(3)
'pchh = RAMG(sp + 249)
'pcll = RAMG(sp + 248)
'pcpp = RAMG(sp + 247)
watch = 2
'PRINT UCASE$(ff$)
PRINT "RL="; HEX$(PAGE&((REG.pc.w - 1) \ SHD) + REG.pc.w - 1 - ROM&); " PC="; HEX$(REG.pc.w - 1); " A="; HEX$(REG.A); " P="; HEX$(REG.P); " S="; HEX$(REG.s); " X="; HEX$(REG.X); " Y="; HEX$(REG.Y);
PRINT " NF="; HEX$(REG.NF); " VF="; HEX$(REG.VF); " ZF="; HEX$(REG.ZF); " ";
'PRINT HEX$(pchh), HEX$(pcll), HEX$(pcpp)
'IF WW THEN PRINT "ZP3"; " ";

'PRINT cycle / (TIMER - ts!);
'PRINT counter&;
'PRINT cycle;
PRINT "OP="; HEX$(I); " "; opcode$(I); ""; 'HEX$(I), cycle

END IF

'RR$ = "RL=" + HEX$(PAGE&((reg.PC.w - 1) \ SHD) + reg.PC.w - 1 - ROM&) + " PC=" + HEX$(reg.PC.w - 1) + " A=" + HEX$(reg.a) + " P=" + HEX$(reg.p) + " S=" + HEX$(reg.S) + " X=" + HEX$(reg.X) + " Y=" + HEX$(reg.Y)
'RR$ = RR$ + " NF=" + HEX$(reg.NF AND &HFF) + " VF=" + HEX$(reg.VF AND &HFF) + " ZF=" + HEX$(reg.ZF AND &HFF) + " OP=" + HEX$(I)


'used to test with hugo core
' IF FF$ <> RR$ THEN
' PRINT
' PRINT "MISMATCH OP #" + HEX$(COUNTER&) + " CYCLE #" + HEX$(cycle)
' PRINT RRR$; " "; OOO$
' PRINT FF$
' PRINT RR$; " "; opcode$(I)
' ENDPROG
' END IF

'OOO$ = opcode$(I)
'RRR$ = RR$

'LINE INPUT #3, f$
'PRINT f$

SELECT CASE I
CASE &HD4'/* CSH set clock highspeed */
CASE &H54'/* CSL set clock lowspeed */

CASE &H44: '/* BSR * REL */   'FIXED
           words REG.pc, REG.pc.w
           cmdr m.push, REG.pc.h
           cmdr m.push, REG.pc.l
           I = op6502(REG.pc.w)
           I = I + (I > 127) * 256
  JUMPSTA(JS).w = REG.pc.w
  JS = JS + 1
  JSS = JSS + 1
  
           REG.pc.w = REG.pc.w + I + 1

CASE &H80: '/* BRA * REL */
          I = op6502(REG.pc.w)
          I = I + (I > 127) * 256
          REG.pc.w = REG.pc.w + I + 1
CASE &H7C: '/* JMP ($ssss,x) */
        M.LDWORD A&: A& = A& + REG.X
        REG.pc.w = op6502w&(A&)

CASE &HDA: cmdr m.push, REG.X  '  /* PHX */
CASE &H5A: cmdr m.push, REG.Y '               /* PHY */
CASE &HFA: cmdr m.pop, REG.X: mfl REG.X '    /* PLX */
CASE &H7A: cmdr m.pop, REG.Y: mfl REG.Y'      /* PLY */

CASE &H62: REG.A = 0' /* CLA */
CASE &H82: REG.X = 0' /* CLX */
CASE &HC2: REG.Y = 0' /* CLY */

CASE &H2:  I = REG.X: REG.X = REG.Y: REG.Y = I'  /* SXY */
CASE &H22: I = REG.A: REG.A = REG.X: REG.X = I'  /* SAX */
CASE &H42: I = REG.A: REG.A = REG.Y: REG.Y = I'  /* SAY */

CASE &H3A: cmdr M.DEC, REG.A                  ' /* DEC A */
CASE &H1A: cmdr m.inc, REG.A                  ' /* INC A */



CASE &HD2: cmdr mr.id, I: M.CMP REG.A, I       '/* CMP ($ss) INDIR */
CASE &HB2: cmdr mr.id, REG.A: mfl REG.A '/* LDA ($ss) INDIR */
CASE &H92: cmdc mc.id, A&: Wr6502 A&, REG.A'/* STA ($ss) INDIR */

CASE &HF4: ' /* SET */
        I = nop6502
        cycle = cycle + cycleS(I) + 3
        cmdd CMDSET1(I), CMDSET2(I)  'IF ERROR, TAKE BACK OFF CYCLES(I)


CASE &H3: io_write 0, nop6502  '/* ST0 */
CASE &H13: io_write 2, nop6502 '/* ST1 */
CASE &H23: io_write 3, nop6502 '/* ST2 */

CASE &H43: '/* TMAi */
          I = nop6502
          FOR II = 0 TO 7
              IF (I AND 2 ^ II) THEN EXIT FOR
          NEXT II
          REG.A = REG.MPR(II)
CASE &H53: '/* TAMi */
         I = nop6502
         FOR II = 0 TO 7
              IF I AND 2 ^ II THEN REG.MPR(II) = REG.A: BANK.SET II, REG.A
         NEXT II

CASE &HC3: ' /* TDD */
'REG.pc.w = REG.pc.w + 6
'GOTO endselect
        T_INIT src&, dist&, LENGTH&
        DO
        Wr6502 dist&, Rd6502(src&)
        dist& = dist& - 1
        src& = src& - 1
        LENGTH& = LENGTH& - 1
        LOOP WHILE LENGTH&

CASE &H73: ' /* TII */
'REG.pc.w = REG.pc.w + 6
'GOTO endselect
        T_INIT src&, dist&, LENGTH&


        DO
             Wr6502 dist&, Rd6502(src&)
             dist& = dist& + 1
             src& = src& + 1
             LENGTH& = LENGTH& - 1
        LOOP WHILE LENGTH&


CASE &HE3: ' /* TIA */
'REG.pc.w = REG.pc.w + 6
'GOTO endselect
        T_INIT src&, dist&, LENGTH&
        DO
                Wr6502 dist&, Rd6502(src&)
                src& = src& + 1
                LENGTH& = LENGTH& - 1
                IF LENGTH& = 0 THEN EXIT DO
                Wr6502 dist& + 1, Rd6502(src&)
                src& = src& + 1
                lenght& = LENGTH& - 1
        LOOP WHILE LENGTH&


CASE &HF3: ' /* TAI */
'REG.pc.w = REG.pc.w + 6
'GOTO endselect
        
        T_INIT src&, dist&, LENGTH&


         DO
               Wr6502 dist&, Rd6502(src&)
               dist& = dist& + 1
               LENGTH& = LENGTH& - 1
               IF LENGTH& = 0 THEN EXIT DO
               Wr6502 dist&, Rd6502(src& + 1)
               dist& = dist& + 1
               LENGTH& = LENGTH& - 1
         LOOP WHILE LENGTH&
        

CASE &HD3: ' /* TIN */
'REG.pc.w = REG.pc.w + 6
'GOTO endselect
        T_INIT src&, dist&, LENGTH&
        DO
                Wr6502 dist&, Rd6502(src&)
                src& = src& + 1
                LENGTH& = LENGTH& - 1
        LOOP WHILE LENGTH&


CASE &H83: '/* TST #$ss,$ss IMM,ZP */
        I = nop6502: II = RAMG(MCZp())
        REG.NF = II
        REG.VF = II: REG.ZF = I AND II

CASE &HA3: '/* TST #$ss,$ss,x IMM,ZP,x */
        I = nop6502: II = RAMG(MCZx())
        REG.NF = II
        REG.VF = II: REG.ZF = I AND II
CASE &H93: '/* TST #$ss,$ssss IMM,ABS */
        I = nop6502: cmdr mr.ab, II
        REG.NF = II
        REG.VF = II: REG.ZF = I AND II

CASE &HB3: '/* TST #$ss,$ssss,x IMM,ABS,x */
        I = nop6502: cmdr mr.ax, II
        REG.NF = II
        REG.VF = II: REG.ZF = I AND II

'SBC
 
CASE &H10: IF (REG.NF AND N.FLAG) THEN REGINC ELSE M.JR  '/* BPL * REL */
CASE &H30: IF (REG.NF AND N.FLAG) THEN M.JR ELSE REGINC  '/* BMI * REL */
CASE &HD0: IF REG.ZF = 0 THEN REGINC ELSE M.JR      '/* BNE * REL */
CASE &HF0: IF REG.ZF = 0 THEN M.JR ELSE REGINC     '/* BEQ * REL */
CASE &H90: IF (REG.P AND c.flag) THEN REGINC ELSE M.JR '/* BCC * REL */
CASE &HB0: IF (REG.P AND c.flag) THEN M.JR ELSE REGINC '/* BCS * REL */
CASE &H50: IF (REG.VF AND V.FLAG) THEN REGINC ELSE M.JR'/* BVC * REL */
CASE &H70: IF (REG.VF AND V.FLAG) THEN M.JR ELSE REGINC '/* BVS * REL */


CASE &H40: '/* RTI */

  I = REG.P  ''''why assign to I

  cmdr m.pop.p, REG.P

  IF ((REG.irequest <> int.none) AND (I AND I.FLAG) <> 0 AND NOT (REG.P AND I.FLAG) <> 0) THEN
     REG.AfterCLI = 1
    REG.IBACKUP = REG.icount
    REG.icount = 0
    END IF
    cmdr m.pop, REG.pc.l
    cmdr m.pop, REG.pc.h
    REG.pc.w = word(REG.pc)
   ' PRINT "return to "; HEX$(reg.pc.w)
CASE &H60: '/* RTS */
  V& = REG.pc.w - 1
  cmdr m.pop, REG.pc.l: cmdr m.pop, REG.pc.h': REGINC REG.PC
  REG.pc.w = word(REG.pc) + 1
  JS = JS - 1
  O& = JUMPSTA(JS).w + 1
  JUMPSTA(JS).w = 0
  IF watch = 2 THEN PRINT "(" + HEX$(O&) + ")"; " ";
  IF REG.pc.w <> O& THEN
  PRINT "RTS @" + HEX$(V&); "GOTO " + HEX$(O&); "WENT " + HEX$(REG.pc.w)
  PRINT "RTS #" + HEX$(JSS) + "RTS STACK #"; JS
  END IF
CASE &H20: '/* JSR $ssss ABS */
  A& = op6502w&(REG.pc.w): REGINC
  cmdr m.push, REG.pc.h
  cmdr m.push, REG.pc.l
  
  JUMPSTA(JS).w = REG.pc.w
  JS = JS + 1
  JSS = JSS + 1
  REG.pc.w = A&
CASE &H4C: M.LDWORD A&: REG.pc.w = A&'/* JMP $ssss ABS */

CASE &H6C: '/* JMP ($ssss) ABDINDIR */
  M.LDWORD A&
  REG.pc.w = op6502w&(A&)

CASE &H0: '/* BRK */
  REGINC
  cmdr m.push, REG.pc.h: cmdr m.push, REG.pc.l
  cmdr m.push.p, REG.P AND Tn.flag OR (b.flag)
  REG.P = (REG.P OR I.FLAG) AND Dn.FLAG
  A& = REG.pc.w
  REG.pc.l = op6502(VEC.BRK)
  REG.pc.h = op6502(VEC.BRK + 1)
  PRINT ERR, "BRK instruction " + HEX$(A& - 1)
  endprog

CASE &H58: '/* CLI */

  IF ((REG.irequest <> int.none) AND (REG.P AND I.FLAG) <> 0) THEN
  
    REG.AfterCLI = 1
    REG.IBACKUP = REG.icount
    REG.icount = 0

  END IF
  REG.P = REG.P AND IN.FLAG



CASE &H28: '/* PLP */

  cmdr m.pop.p, I

  IF ((REG.irequest <> int.none) AND ((I XOR REG.P) AND notb(I) AND I.FLAG) <> 0) THEN

    REG.AfterCLI = 1
    REG.IBACKUP = REG.icount
    REG.icount = 0

  END IF
  REG.P = I



CASE &H8: cmdr m.push.p, REG.P AND Tn.flag OR b.flag'     /* PHP */
CASE &H18: REG.P = REG.P AND cn.flag          '     /* CLC */
CASE &HB8: REG.VF = 0                              '     /* CLV */
CASE &HD8: REG.P = REG.P AND Dn.FLAG          '     /* CLD */
CASE &H38: REG.P = REG.P OR c.flag                 '     /* SEC */
CASE &HF8: REG.P = REG.P OR D.flag                 '     /* SED */
CASE &H78: REG.P = REG.P OR I.FLAG                 '     /* SEI */
CASE &H48: cmdr m.push, REG.A          '             /* PHA */
CASE &H68: cmdr m.pop, REG.A: mfl REG.A       '     /* PLA */
CASE &H98: REG.A = REG.Y: mfl REG.A     '     /* TYA */

'can i use cmdr m.inc, reg.y ?
CASE &HA8: REG.Y = REG.A: mfl REG.Y     '     /* TAY */
CASE &HC8: REG.Y = REG.Y + 1: mfl REG.Y '     /* INY */
CASE &H88: REG.Y = REG.Y - 1: mfl REG.Y '     /* DEY */
CASE &H8A: REG.A = REG.X: mfl REG.A     '     /* TXA */
CASE &HAA: REG.X = REG.A: mfl REG.X     '     /* TAX */
CASE &HE8: REG.X = REG.X + 1: mfl REG.X '     /* INX */
CASE &HCA: REG.X = REG.X - 1: mfl REG.X '     /* DEX */
CASE &HEA:  '                                  /* NOP */
CASE &H9A: REG.s = REG.X                 '     /* TXS */
CASE &HBA: REG.X = REG.s: mfl REG.X     '     /* TSX */
CASE &H84: cmdr mw.zp, REG.Y                 '  /* STY $ss ZP */
CASE &H85: cmdr mw.zp, REG.A                '  /* STA $ss ZP */
CASE &H86: cmdr mw.zp, REG.X                 '  /* STX $ss ZP */
CASE &HA4: cmdr mr.zp, REG.Y: mfl REG.Y    '  /* LDY $ss ZP */
CASE &HA5: cmdr mr.zp, REG.A: mfl REG.A    '  /* LDA $ss ZP */
CASE &HA6: cmdr mr.zp, REG.X: mfl REG.X     '  /* LDX $ss ZP */
CASE &HC4: cmdr mr.zp, I: M.CMP REG.Y, I     '  /* CPY $ss ZP */
CASE &HC5: cmdr mr.zp, I: M.CMP REG.A, I     '  /* CMP $ss ZP */
CASE &HE4: cmdr mr.zp, I: M.CMP REG.X, I    '  /* CPX $ss ZP */
CASE &H8C: cmdr mw.ab, REG.Y                 '  /* STY $ssss ABS */
CASE &H8D: cmdr mw.ab, REG.A               '  /* STA $ssss ABS */
CASE &H8E: cmdr mw.ab, REG.X                '  /* STX $ssss ABS */
CASE &HAC: cmdr mr.ab, REG.Y: mfl REG.Y     '  /* LDY $ssss ABS */
CASE &HAD: cmdr mr.ab, REG.A: mfl REG.A    '  /* LDA $ssss ABS */
CASE &HAE: cmdr mr.ab, REG.X: mfl REG.X     '  /* LDX $ssss ABS */
CASE &HCC: cmdr mr.ab, I: M.CMP REG.Y, I     '  /* CPY $ssss ABS */
CASE &HCD: cmdr mr.ab, I: M.CMP REG.A, I     '  /* CMP $ssss ABS */
CASE &HEC: cmdr mr.ab, I: M.CMP REG.X, I    '  /* CPX $ssss ABS */
CASE &HA0: cmdr mr.im, REG.Y: mfl REG.Y     '  /* LDY #$ss IMM */
CASE &HA2: cmdr mr.im, REG.X: mfl REG.X     '  /* LDX #$ss IMM */
CASE &HA9: cmdr mr.im, REG.A: mfl REG.A     '  /* LDA #$ss IMM */
CASE &HC0: cmdr mr.im, I: M.CMP REG.Y, I     '  /* CPY #$ss IMM */
CASE &HC9: cmdr mr.im, I: M.CMP REG.A, I     '  /* CMP #$ss IMM */
CASE &HE0: cmdr mr.im, I: M.CMP REG.X, I    '  /* CPX #$ss IMM */
CASE &H94: cmdr mw.zx, REG.Y                 '  /* STY $ss,x ZP,x */
CASE &H95: cmdr mw.zx, REG.A                 '  /* STA $ss,x ZP,x */
CASE &H96: cmdr mw.zy, REG.X                 '  /* STX $ss,y ZP,y */
CASE &HB4: cmdr mr.zx, REG.Y: mfl REG.Y     '  /* LDY $ss,x ZP,x */
CASE &HB5: cmdr mr.zx, REG.A: mfl REG.A     '  /* LDA $ss,x ZP,x */
CASE &HB6: cmdr mr.zy, REG.X: mfl REG.X     '  /* LDX $ss,y ZP,y */
CASE &HD5: cmdr mr.zx, I: M.CMP REG.A, I     '  /* CMP $ss,x ZP,x */
CASE &H99: cmdr mw.ay, REG.A                 '  /* STA $ssss,y ABS,y */
CASE &H9D: cmdr mw.ax, REG.A                 '  /* STA $ssss,x ABS,x */
CASE &HB9: cmdr mr.ay, REG.A: mfl REG.A     '  /* LDA $ssss,y ABS,y */
CASE &HBC: cmdr mr.ax, REG.Y: mfl REG.Y     '  /* LDY $ssss,x ABS,x */
CASE &HBD: cmdr mr.ax, REG.A: mfl REG.A     '  /* LDA $ssss,x ABS,x */
CASE &HBE: cmdr mr.ay, REG.X: mfl REG.X     '  /* LDX $ssss,y ABS,y */
CASE &HD9: cmdr mr.ay, I: M.CMP REG.A, I     '  /* CMP $ssss,y ABS,y */
CASE &HDD: cmdr mr.ax, I: M.CMP REG.A, I     '  /* CMP $ssss,x ABS,x */
CASE &H81: cmdr mw.ix, REG.A                 '  /* STA ($ss,x) INDEXINDIR */
CASE &H91: cmdr mw.iy, REG.A                 '  /* STA ($ss),y INDIRINDEX */
CASE &HA1: cmdr mr.ix, REG.A: mfl REG.A     '  /* LDA ($ss,x) INDEXINDIR */
CASE &HB1: cmdr mr.iy, REG.A: mfl REG.A     '  /* LDA ($ss),y INDIRINDEX */
CASE &HC1: cmdr mr.ix, I: M.CMP REG.A, I     '  /* CMP ($ss,x) INDEXINDIR */
CASE &HD1: cmdr mr.iy, I: M.CMP REG.A, I     '  /* CMP ($ss),y INDIRINDEX */
CASE &HA:  cmdr m.asl, REG.A                 '  /* ASL a ACC */
CASE &H2A: cmdr M.ROL, REG.A                '  /* ROL a ACC */
CASE &H4A: cmdr M.LSR, REG.A                '  /* LSR a ACC */
CASE &H6A: cmdr M.ROR, REG.A                '  /* ROR a ACC */

CASE IS = ((CMD1(I) <> 0) AND I): cmdd (CMD1(I)), (CMD2(I))
CASE IS = ((CMR1(I) <> 0) AND I): cmdr (CMR1(I)), (CMR2(I))
CASE IS = (I OR &H8F) '/BBSi
IF (RAMG(MCZp())) AND (2 ^ ((I XOR &H80) \ SH4)) THEN M.JR ELSE REGINC 'BBRI
CASE IS = (I OR &HF) '/* BBRi
IF (RAMG(MCZp())) AND (2 ^ (I \ SH4)) THEN REGINC ELSE M.JR 'BBSi

CASE ELSE
tt! = TIMER
PRINT cycle / (tt! - ts!), COUNTER& / (tt! - ts!), tt! - ts!
PRINT cycle, COUNTER&
PRINT
PRINT "ERROR:"; HEX$(REG.pc.w - 1), HEX$(I): endprog
'default:
'  if(_TrapBadOps) {
'    fprintf
'    ( stderr,
'      "[M6502 %lX] Unrecognized instruction: $%02X at PC=$%04X\n",
'      (unsigned)_User,Op6502(REG.PC.W-1),(word)(REG.PC.W-1)
'    );
'
'    _Trace=1;
'
'  }
'
'  break;
END SELECT
endselect:
IF watch = 2 THEN
watch = 1
PRINT
kk$ = INPUT$(1)
'watch = 0
END IF

NEXTCODES:
END SUB

SUB endprog ()
VMMEND
END
END SUB

SUB Int6502 (ttype)
'PRINT "int @ "; HEX$(reg.pc.w), cycle

'watch = 1
'void Int6502(M6502 *R,byte ttype)
'{
'  register pair J;
'
'/*  if((ttype==INT_NMI)||(!(_P&I_FLAG)))
'  {
'        M_PUSH(_PC.B.h);
'    M_PUSH(_PC.B.l);
'    M_PUSH_P(_P&~(B_FLAG|T_FLAG));
'
''
'    if (ttype==INT_NMI){
'
'        J.W=VEC_NMI;
'
'    } else {
'
'
'    switch(ttype){
'
'    case INT_IRQ:J.W=VEC_IRQ;break;
'
'    case INT_IRQ2:J.W=VEC_IRQ2;break;
'
'    case INT_TIMER:J.W=VEC_TIMER;break;
'
'
'    }

''    }
'          } else {
'
'
'  }
'  */

IF ((ttype = INT.NMI) OR (NOT (REG.P AND I.FLAG))) THEN

    REG.icount = REG.icount - 7



    words REG.pc, REG.pc.w
    
    RAMp sp + REG.s, REG.pc.h: REG.s = REG.s - 1
    RAMp sp + REG.s, REG.pc.l: REG.s = REG.s - 1

'//    #define M_PUSH_P(Rg)  M_PUSH(((Rg)&~(N_FLAG|V_FLAG|Z_FLAG))|(_NF&N_FLAG)|(_VF&V_FLAG)|(_ZF? 0:Z_FLAG))

    RAMp sp + REG.s, ((REG.P AND notb(b.flag OR T.FLAG)) AND notb(N.FLAG OR V.FLAG OR z.flag)) OR (REG.NF AND N.FLAG) OR (REG.VF AND V.FLAG) OR ((REG.ZF = 0) AND z.flag): REG.s = REG.s - 1

    REG.P = REG.P AND Dn.FLAG

    IF (ttype = INT.NMI) THEN

        j& = VEC.NMI
    ELSE

        REG.P = REG.P OR I.FLAG

        SELECT CASE (ttype)

         CASE INT.IRQ: j& = VEC.IRQ

         CASE INT.IRQ2: j& = VEC.IRQ2

         CASE INT.TIMER: j& = VEC.TIMER
        END SELECT
    END IF
    'reg.pc.l = op6502(J&)
    'reg.pc.h = op6502(J& + 1)
    'reg.pc.w = word(reg.pc)
     REG.pc.w = op6502w(j&)
 '    PRINT HEX$(reg.pc.w)

ELSE

      REG.irequest = REG.irequest OR ttype

END IF



END SUB

FUNCTION io_read (A&)
'PRINT "io_read "; HEX$(a&); ': END
'EXIT FUNCTION
SELECT CASE A AND &H1C00
 CASE &H0: 'PRINT "vdc"; a AND &HFF;
          A = A AND 3
          SELECT CASE A
           CASE 0 'read status
             io_read = io.vdc_status
             io.vdc_status = 0
             'io_read = 2 ^ 6 'vd on
           CASE 2, 3

            SELECT CASE io.VDC_REG
             CASE VDC_RRR: 'vrr  vram read low/high
                          
                  SELECT CASE A
                  CASE 2: io.vdc(vdc_vrr).l = vramg(word(io.vdc(vdc_marr)) * 2)     'low
                  CASE 3: io.vdc(vdc_vrr).h = vramg(word(io.vdc(vdc_marr)) * 2 + 1) 'high  .w=.h|l
                          words io.vdc(vdc_marr), io.vdc(vdc_marr).w + io.vdc_inc   '.w,.h|l = .w + 1
                  END SELECT
            END SELECT

            SELECT CASE A
              CASE 2: io_read = io.vdc(io.VDC_REG).l 'lsb
              CASE 3: io_read = io.vdc(io.VDC_REG).h 'msb
            END SELECT
          END SELECT
          



 CASE &H400: 'PRINT "vce"; a AND &HFF;
 CASE &H800: 'PRINT "psg"; a AND &HFF;
 CASE &HC00: 'PRINT "timer"; a AND &HFF;
             io_read = io.timer_counter

 CASE &H1000: 'PRINT "joypad"; a AND &HFF;
             RET = io.JOY(io.JOY_COUNTER) XOR &HFF
             IF io.JOY_SELECT AND 1 THEN
              RET = RET \ SH4
             ELSE
              RET = RET AND &HF: io.JOY_COUNTER = (io.JOY_COUNTER + 1) MOD 5
             END IF
             io_read = RET OR COUNTRY '0 JPN 1 USA

 CASE &H1400: 'PRINT "irq"; a AND &HFF;
             SELECT CASE A& AND 15
              CASE 2: io_read = io.irq_mask: EXIT FUNCTION
              CASE 3: RET = io.irq_status: io.irq_status = 0: io_read = RET: EXIT FUNCTION
              END SELECT


 CASE &H1800: 'PRINT "cd-rom"; a AND &HFF;
 CASE ELSE: PRINT "io_read "; HEX$(A)
            K$ = INPUT$(1)
END SELECT

EXIT FUNCTION
'byte IO_read(word A)
'byte ret

  SELECT CASE A& AND &H1C00
  CASE &H0:    '/* VDC */
          SELECT CASE A& AND 3
          CASE 0:
            RET = io.vdc_status
            io.vdc_status = 0';//&=VDC_InVBlank;//&=~VDC_BSY;
            io_read = RET: EXIT FUNCTION
          CASE 1:
            io_read = 0: EXIT FUNCTION
          CASE 2:
            IF (io.VDC_REG = vrr) THEN
               io_read = vramg(word(io.vdc(marr)) * 2): EXIT FUNCTION
            ELSE
               io_read = io.vdc(io.VDC_REG).l: EXIT FUNCTION
            END IF
          CASE 3:
            IF (io.VDC_REG = vrr) THEN
               RET = vramg(word(io.vdc(marr)) * 2 + 1)
               words io.vdc(marr), word(io.vdc(marr)) + io.vdc_inc
               io_read = RET: EXIT FUNCTION
             ELSE
               io_read = io.vdc(io.VDC_REG).h: EXIT FUNCTION
             END IF
          END SELECT
    

  CASE &H400: '/* VCE */
    SELECT CASE A& AND 7
    CASE 4: io_read = io.VCE(word(io.vce_reg)).l: EXIT FUNCTION
    CASE 5: io_read = io.VCE(word(io.vce_reg)).h: words io.vce_reg, word(io.vce_reg) + 1: EXIT FUNCTION
    END SELECT
    
'#ifndef FINAL_RELEASE
'  case 0x0800:  /* PSG */
'    switch(A&15){
'    case 0: return io.psg_ch;
'    case 1: return io.psg_volume;
'    case 2: return io.PSG[io.psg_ch][2];
'    case 3: return io.PSG[io.psg_ch][3];
'    case 4: return io.PSG[io.psg_ch][4];
'    case 5: return io.PSG[io.psg_ch][5];
'    CASE 6:
'        {
'            //int   ofs=io.wavofs[io.psg_ch];
'            //io.wavofs[io.psg_ch]=(io.wavofs[io.psg_ch]+1)&31;
'            //return io.wave[io.psg_ch][ofs];
'            int ofs=fixtoi(snd_pos[io.psg_ch]);
'            snd_pos[io.psg_ch]=itofix((fixtoi(snd_pos[io.psg_ch])+1)&31);
'            return io.wave[io.psg_ch][ofs];
'
'        }
'    case 7: return io.PSG[io.psg_ch][7];
'    case 8: return io.psg_lfo_freq;
'    case 9: return io.psg_lfo_ctrl;
'    default: return NODATA;
'    }
'    break;
'#endif
  CASE &HC00:  ' /* timer */
    io_read = io.timer_counter: EXIT FUNCTION

  CASE &H1000:  '/* joypad */

  
    RET = io.JOY(io.JOY_COUNTER) XOR &HFF
          IF io.JOY_SELECT AND 1 THEN
            RET = RET \ SH4
          ELSE
            RET = RET AND 15: io.JOY_COUNTER = (io.JOY_COUNTER + 1) MOD 5
          END IF
            io_read = RET OR COUNTRY: EXIT FUNCTION'; /* country 0:JPN 1=US */


  CASE &H1400: ' /* IRQ */
    SELECT CASE A& AND 15
    CASE 2: io_read = io.irq_mask: EXIT FUNCTION
    CASE 3: RET = io.irq_status: io.irq_status = 0: io_read = RET: EXIT FUNCTION
    END SELECT
    

  CASE &H1800: ' /* CD-ROM extention */
    SELECT CASE A& AND 15
    CASE 3: io.backup = DISABLE: io_read = DISABLE: EXIT FUNCTION'return io.backup = disable
'//  case 0xa:
'//      if (!io.adpcm_firstread) return PCM[io.adpcm_rptr++];
'//      else {io.adpcm_firstread=FALSE; return NODATA;}
    END SELECT
    
    
  END SELECT
    io_read = NODATA


END FUNCTION

SUB io_write (A AS LONG, V)
'PRINT "io_write "; HEX$(a);
SELECT CASE A AND &H1C00
 CASE &H0


   A = A AND 3
   SELECT CASE A
    CASE 0: io.VDC_REG = V AND &H1F 'reg select bit 0 - 4
    CASE 2, 3: 'lsb/msb data
             
     SELECT CASE A
       CASE 2: io.vdc(io.VDC_REG).l = V 'lsb
              'EXIT SUB
       CASE 3: io.vdc(io.VDC_REG).h = V 'msb
     END SELECT
     V& = word(io.vdc(io.VDC_REG)): io.vdc(io.VDC_REG).w = V&

  
     SELECT CASE io.VDC_REG
      CASE VDC_VWR 'r/w vrr/vwr    'read vram at marr/write vram at mawr
                 SELECT CASE A
                 CASE 2:
                         vramp io.vdc(MAWR).w * 2, V        'low
                 CASE 3: vramp io.vdc(MAWR).w * 2 + 1, V    'high
                         words io.vdc(MAWR), io.vdc(MAWR).w + io.vdc_inc
                 END SELECT
      CASE vdc_cr
            
                 ''v& = io.vdc(vdc_cr).w   v&'GET FULL WORD


                  'BITS 0 - 5
                  io.VDC_SCD = V& AND &H1    'B0       'SPRITE COLLISION DETECTION INT
                  io.VDC_SND = V& AND &H2    'B1       'SPRITE NUMBER DETECTION INT
                  io.VDC_RSR = V& AND &H4    'B2       'RCR  ON/OFF
                  io.VDC_IRQ = V& AND &H8    'B3       'IRQ ON/OFF
                  'SELECT CASE V& AND &H30    'B4-B5
                  ' CASE &H0: 'VSYNC, HSYNC INPUTS
                  ' CASE &H10: 'VSYNC INPUT, HSYNC OUTPUT
                  ' CASE &H20: 'NOT USED
                  ' CASE &H30: 'VSYNC,HSYNC OUTPUT
                  'END SELECT
                  io.VDC_SPRITES = V& AND &H40    'B6  'SPRITES ON
                  io.VDC_BACKGROUND = V& AND &H80 'B7  'BACKGROUND ON
                  'B8-B9   SELECTION OF TERMINAL OUTPUTS    (TE)
                  '    00  DISP OUTPUT "H" DURING DISPLAY
                  '    01  BURST COLOR BURST INSERTING POSITION IS INDICATED BY
                  '        OUTPUT "L"
                  '    10  INTHSYNC INTERNAL HORIZONTAL SYNCHRONOUS
                  '    11  NOT USED
                  '
                  'B10     DYNAMIC RAM REFRESH (DR)
                  
                  SELECT CASE V& AND &H18    'B11-B12
                   CASE &H0:    io.vdc_inc = 1
                   CASE &H800:  io.vdc_inc = 32
                   CASE &H1000: io.vdc_inc = 64
                   CASE &H1800: io.vdc_inc = 128
                  END SELECT
                  'B13-B15 NOT USED

                  sphiton = (V& AND &H1) <> 0
                  overon = (V& AND &H2) <> 0
                  rashiton = (V& AND &H4) <> 0
                  vblankon = (V& AND &H8) <> 0
                  spriteon = (V& AND &H4) <> 0
                  screenon = (V& AND &H80) <> 0
                   
      CASE vdc_VDW:

                        
                        io.screen_h = (V& AND 511) + 1
                        maxline = io.screen_h - 1

      

      CASE vdc_hdr
                        ' b14-8 hde horizontal display ending period - 1
                        ' b6-0  hdw horizontal display width in tiles - 1
                        'mask = 7f7f
                        
                        io.screen_w = ((V& AND &H7F) + 1) * 8
''need to work on
      CASE vdc_mwr
                       'b7  cm (color mode)
                       'b6-4 screen
                       '     b6   0=256pixels/32tiles screen height
                       '          1=512pixels/64tiles
                       '     b5-4 00=256pixels/32tiles
                       '          01=512pixels/64tiles
                       '          10,11=1024pixels/128tiles
                       '     b3-2 sprite dot width
                       '     b1-0 VRAM dot width
      'case vdr_HSR horizontal sync register
                       'b14-8 HDS (start position)-1
                       'b4-0 pulse width
                       '$7f1f
     'case vdc_vpr verticle sync register
                       'b14-8 vds (start pos)-2
                       'b4-0  vsw(pulse width)

     'case vdc_vcr     '7-0 verticle display end position



      CASE ELSE
         'PRINT "VDC "; HEX$(a); ","; HEX$(V), "VG="; HEX$(io.VDC_REG)
     END SELECT
   END SELECT

 CASE &H400: 'PRINT "vce"; a AND &HFF;   'DONT NEED TO IMPLEMENT YET
 CASE &H800: 'PRINT "psg"; a AND &HFF;   'DONT NEED TO IMPLEMENT YET
 CASE &HC00: 'PRINT "timer"; a AND &HFF;
       SELECT CASE A AND 1
       CASE 0: io.timer_reload = V AND &H7F
       CASE 1: V = V AND 1
               IF V AND (io.timer_start = 0) THEN : io.timer_counter = io.timer_reload
               io.timer_start = V
       END SELECT


 CASE &H1000: 'PRINT "joypad"; a AND &HFF;
       io.JOY_SELECT = V AND 1
       IF V AND 2 THEN io.JOY_COUNTER = 0

 CASE &H1400: 'PRINT "irq"; a AND &HFF;

       SELECT CASE A AND &HF
       CASE 2: io.irq_mask = V
       CASE 3: io.irq_status = (io.irq_status AND notb(tirq)) OR (V AND &HF8)
       END SELECT
       'PRINT v, HEX$(a)


 CASE &H1800: 'PRINT "cd-rom"; a AND &HFF;    'DONT NEED TO IMPLEMENT YET
 CASE ELSE: PRINT "io_write "; HEX$(A);
            K$ = INPUT$(1)
END SELECT




EXIT SUB

'A,v
  SELECT CASE A AND &H1C00
  CASE &H0:     '/* VDC */
        SELECT CASE A AND 3
        CASE 0: io.VDC_REG = V AND 31: EXIT SUB:
        CASE 1: EXIT SUB
        END SELECT
        CASE 2:
       
             SELECT CASE io.VDC_REG
             CASE vwr:
             CASE hdr:
'                        io.screen_w = (V + 1) * 8:
                        
                        

             CASE mwr:
'                        'static byte bgw[]={32,64,128,128}:
'                        'io.bg_h=(V AND &h40)?64:32:
'                        'io.bg_w=bgw[(V>>4) AND 3]:}
'
'
'
             CASE byr:
                 IF scroll = 0 THEN
                                oldScrollX = ScrollX:
                                oldScrollY = ScrollY:
                                oldScrollYDiff = ScrollYDiff:
                 END IF
                        io.vdc(byr).l = V:
                        scroll = 1:
                                ScrollYDiff = scanline - 1:
                        EXIT SUB:
        CASE bxr:
            IF scroll = 0 THEN
                                oldScrollX = ScrollX:
                                oldScrollY = ScrollY:
                                oldScrollYDiff = ScrollYDiff:
            END IF
                        io.vdc(bxr).l = V:
                        scroll = 1:
                        EXIT SUB:


        END SELECT
                io.vdc(io.VDC_REG).l = V:
                EXIT SUB:
    CASE 3:

        SELECT CASE io.VDC_REG
        CASE vwr:
                 
                        vramp word(io.vdc(MAWR)) * 2, io.VDC_ratch:
                        vramp word(io.vdc(MAWR)) * 2 + 1, V
                        'vchanges(io.VDC(MAWR).W / 64) = 1:
                        'io.VDC[MAWR].W+=io.vdc_inc:
                        io.VDC_ratch = 0:
                        EXIT SUB:
        CASE VDW:
                        
                        io.vdc(VDW).h = V:
                        'io.screen_h = (io.VDC(VDW).W AND 511) + 1:
                        'MaxLine = io.screen_h - 1:
                        
                        EXIT SUB:
        CASE lenr:
                        
                        io.vdc(lenr).h = V:
                        
            '/* VRAM to VRAM DMA */
            'memcpy(VRAM+io.VDC[DISTR].W*2,VRAM+io.VDC[SOUR].W*2,
            '                    (io.VDC[LENR].W+1)*2):
            '            memset(vchange+io.VDC[DISTR].W/16,1,(io.VDC[LENR].W+1)/16):
            '            memset(vchange+io.VDC[DISTR].W/64,1,(io.VDC[LENR].W+1)/64):
'                        io.VDC[DISTR].W += io.VDC[LENR].W+1:
'                        io.VDC[SOUR].W += io.VDC[LENR].W+1:
'                        io.vdc_status|=VDC_DMAfinish:
'                        EXIT SUB:
        CASE cr:
'                        static byte incsize[]={1,32,64,128}:
'                        io.vdc_inc = incsize[(V>>3) AND 3]:
                        
            

        CASE hdr:
            
            
                        
        CASE byr:
'            IF (scroll = 0) THEN
'                                oldScrollX = ScrollX:
'                                oldScrollY = ScrollY:
'                                oldScrollYDiff = ScrollYDiff:
'            END IF
'                        io.VDC(BYR).B.h = V AND 1:
'                        scroll = 1:
'                                ScrollYDiff = scanline - 1:
'
                        EXIT SUB:
        CASE satb:
'                        io.VDC(SATB).B.h = V:
'
'
'                        io.vdc_satb = 1:
'                        io.vdc_status AND =~VDC_SATBfinish:
'                        EXIT SUB:
        CASE bxr:
'            IF (scroll = 0) THEN
'                                oldScrollX = ScrollX:
'                                oldScrollY = ScrollY:
'                                oldScrollYDiff = ScrollYDiff:
'            END IF
 '                       io.VDC(BXR).B.h = V AND 3:
'                        scroll = 1:
'                        EXIT SUB:


  '      END SELECT
                
'                io.VDC(io.vdc_reg).B.h = V:
'                EXIT SUB:
    END SELECT


  CASE &H400:   '/* VCE */
        SELECT CASE (A AND 7)
        CASE 0:
                
        CASE 2: io.vce_reg.l = V: EXIT SUB:
        CASE 3: io.vce_reg.h = V AND 1: EXIT SUB:
        CASE 4: io.VCE(word(io.vce_reg)).l = V:
'
'                 byte c: int i,n:
                 N = word(io.vce_reg)
                 c = word(io.VCE(N)) \ sh1
         IF N = 0 THEN
                FOR II = O TO 255 STEP 16: Pal(II) = c: NEXT II
'                        for(i=0:i<256:i+=16) Pal[i]=c:
         ELSE IF (N AND 15) THEN Pal(N) = c:
        END IF


                EXIT SUB:
    CASE 5:
                io.VCE(word(io.vce_reg)).h = V:
        
'                 byte c: int i,n:
                 N = word(io.vce_reg)
                 c = word(io.VCE(N)) \ sh1
        IF N = 0 THEN
        FOR II = 0 TO 255 STEP 16: Pal(II) = c: NEXT II
'                        'for(i=0:i<256:i+=16) Pal[i]=c:
             ELSE IF (N AND 15) THEN Pal(N) = c:
        END IF
                words io.vce_reg, (word(io.vce_reg) + 1) AND &H1FF:
                EXIT SUB

        CASE 1:
        CASE 6:
        CASE 7:
    END SELECT
 


  CASE &HC00:   '/* timer */
        
        SELECT CASE A AND 1
        CASE 0: io.timer_reload = V AND 127: EXIT SUB:
        CASE 1:
                V = V AND 1:
                IF (V <> 0 AND io.timer_start = 0) THEN io.timer_counter = io.timer_reload:
                io.timer_start = V:
                EXIT SUB:
    END SELECT
        

  CASE &H1000: ' /* joypad */

                io.JOY_SELECT = V AND 1:
                IF (V AND 2) THEN io.JOY_COUNTER = 0:
                EXIT SUB:

  CASE &H1400:  '/* IRQ */
        SELECT CASE A AND 15
        CASE 2: io.irq_mask = V:
        CASE 3: io.irq_status = (io.irq_status AND NOT (tirq)) OR (V AND &HF8): EXIT SUB:
    END SELECT
        

  CASE &H1800: ' /* CD-ROM extention */
        SELECT CASE A AND 15
        CASE 7: io.backup = ENABLE: EXIT SUB:
'        CASE 8: IO.ADPCM_PTR..B.L =V:EXIT SUB
'        CASE 9: io.adpcm_ptr.B.h = V: EXIT SUB:
        'case &ha: PCM[io.adpcm_wptr++] = V: exit sub:
'        CASE &HD:
'                if (V AND 4) io.adpcm_wptr = io.adpcm_ptr.W:
'                else { io.adpcm_rptr = io.adpcm_ptr.W: io.adpcm_firstread = TRUE: }
                EXIT SUB:
'*/
   END SELECT
        
  END SELECT


END SUB

FUNCTION Joysticks ()
'PRINT "joystick poll"
END FUNCTION

SUB loadpce (f%)
    PRINT "loadpce:"

    fs& = LOF(f%)
    hdr& = fs& AND &H1FFF
    fsize& = fs& AND NOT (&H1FFF)

    'populus requires pop ram (&h8000) in total for  &h40 - > &h43 inc &h2000
    'find why the processor knows it uses popram?
    ROM& = allocVMM&(fs&)
   'popram& = allocvmm&(&H10000) 'byte    'fill ?
    WRAM& = allocVMM&(&H2000)    'byte
    RAM& = allocVMM&(32768)      'byte
    vram& = allocVMM&(&H10000)   'byte
    ioarea& = allocVMM&(&H2000)  'byte


    DO UNTIL ADR& > fs&     'load rom
    D$ = INPUT$(32767, f%)
    vmmP ROM& + ADR&, D$
    D$ = ""
    ADR& = ADR& + 32767
    LOOP
    CLOSE #f%
    lockvmm ROM&, RAM& - 1
    ROM& = ROM& + hdr&


    ROM.SIZE = fsize& \ &H2000
    rommask = 1
    

WHILE (rommask < ROM.SIZE)
    rommask = rommask * sh1
    WEND
    rommask = rommask - 1
    

    FOR I = 0 TO &HF7

    
        IF (ROM.SIZE = &H30) THEN
        
            SELECT CASE (I AND &H70)
            
            
            
            CASE &H50, &H10, &H0:
                

            
            rommap&(I) = ROM& + (I AND rommask) * 8192&
            
            CASE &H60, &H20:
                
                 

                 rommap&(I) = ROM& + ((I - &H20) AND rommask) * &H2000&
            
            CASE &H70, &H30:

                rommap&(I) = ROM& + ((I - &H10) AND rommask) * &H2000&
                
            CASE &H40:
                'rommap&(I) = rom& + ((I - &H20) AND rommask) * &h2000&

            
            rommap&(I) = ROM& + ((I - &H20) AND rommask) * &H2000&
            END SELECT
        
        ELSE


     rommap&(I) = ROM& + (I AND rommask) * &H2000&
    
       END IF
    NEXT I

    rommap&(&HF7) = WRAM&
    rommap&(&HF8) = RAM&
    rommap&(&HF9) = RAM& + &H2000
    rommap&(&HFA) = RAM& + &H4000
    rommap&(&HFB) = RAM& + &H6000
    rommap&(&HFF) = ioarea&' //NULL; /* NULL = I/O area */









END SUB

STATIC FUNCTION loop6502 ()
'EXIT FUNCTION
'byte loop6502(M6502 * R)
'{
    STATIC UCount: 'UCount = 0

    STATIC ACount: 'ACount = 0
    STATIC prevline
    'int dispmin, dispmax;
    'int ret
 
    IF maxline - minline > maxdisp THEN
                     dispmin = minline + ((maxline - minline - maxdisp + 1) \ sh1)
                     dispmax = maxline - ((maxline - minline - maxdisp + 1) \ sh1)
    ELSE
                     dispmin = minline
                     dispmax = maxline
    END IF

    ''''dispmin = (MaxLine-MinLine>MAXDISP ? MinLine+((MaxLine-MinLine-MAXDISP+1)>>1) : MinLine);
    ''''dispmax = (MaxLine-MinLine>MAXDISP ? MaxLine-((MaxLine-MinLine-MAXDISP+1)>>1) : MaxLine);

    scanline = (scanline + 1) MOD scanlines_per_frame
    RET = int.none
    io.vdc_status = io.vdc_status AND NOT vdc_RasHit
    IF (scanline > maxline) THEN : io.vdc_status = io.vdc_status OR vdc_InVBlank
    'PRINT io.vdc_status, scanline
    IF (scanline = minline) THEN
        io.vdc_status = io.vdc_status AND NOT vdc_InVBlank
        prevline = dispmin
        ScrollYDiff = 0
        oldScrollYDiff = 0

    ELSE
      IF (scanline = maxline) THEN
            IF (CheckSprites()) THEN
                 io.vdc_status = io.vdc_status OR vdc_SpHit
            ELSE io.vdc_status = io.vdc_status AND NOT vdc_SpHit
            END IF

            IF (UCount) THEN
                 UCount = UCount - 1
            ELSE
                 IF (spriteon <> 0 AND SPONSwitch <> 0) THEN RefreshSprite prevline, dispmax, 0

                 RefreshLine prevline, dispmax - 1

                 IF (spriteon <> 0 AND SPONSwitch <> 0) THEN RefreshSprite prevline, dispmax, 1
                 prevline = dispmax
                 UCount = UPeriod
                 RefreshScreen
            END IF

      
      END IF

    END IF





    IF (scanline >= minline AND scanline <= maxline) THEN
        IF (scanline = (io.vdc(VDC_rcr).w AND 1023) - 64) THEN
            IF (rashiton <> 0 AND UCount = 0 AND dispmin <= scanline AND scanline <= dispmax) THEN
                IF (spriteon <> 0 AND SPONSwitch <> 0) THEN RefreshSprite prevline, scanline, 0
                RefreshLine prevline, scanline - 1
                IF (spriteon <> 0 AND SPONSwitch <> 0) THEN RefreshSprite prevline, scanline, 1
                prevline = scanline
            END IF
            io.vdc_status = io.vdc_status OR vdc_RasHit
            IF (rashiton) THEN
                
                RET = INT.IRQ
            END IF
        ELSE
            IF (scroll) THEN
              IF (scanline - 1 > prevline AND UCount = 0) THEN
                  'int tmpScrollX, tmpScrollY, tmpScrollYDiff;
                  tmpScrollX = ScrollX
                  tmpScrollY = ScrollY
                  tmpScrollYDiff = ScrollYDiff
                  ScrollX = oldScrollX
                  ScrollY = oldScrollY
                  ScrollYDiff = oldScrollYDiff
                  IF (spriteon <> 0 AND SPONSwitch <> 0) THEN RefreshSprite prevline, scanline - 1, 0
                  RefreshLine prevline, scanline - 2
                  IF (spriteon <> 0 AND SPONSwitch <> 0) THEN RefreshSprite prevline, scanline - 1, 1
                  prevline = scanline - 1
                  ScrollX = tmpScrollX
                  ScrollY = tmpScrollY
                  ScrollYDiff = tmpScrollYDiff
              END IF
            END IF
        END IF
     ELSE
        rcr = (io.vdc(VDC_rcr).w AND 1023) - 64

        
        IF (scanline = rcr) THEN
        
'//          ScrollYDiff = scanline
            IF (rashiton) THEN
                
                io.vdc_status = io.vdc_status OR vdc_RasHit
                RET = INT.IRQ
            END IF
        END IF
    END IF
    


    scroll = 0
    IF (scanline = maxline + 1) THEN
'//  if (scanline=scanlines_per_frame-63) THEN
           'int
           j = Joysticks()
           IF (j AND &H10000) THEN loop6502 = INT.QUIT: EXIT FUNCTION
           io.JOY(0) = j
'error
        '/* VRAM to SATB DMA */
           IF (io.vdc_satb = 1 OR (io.vdc(vdc_dcr).w AND &H10) <> 0) THEN
        
              'memcpy(SPRAM,VRAM+io.VDC[vdc_SATB].W*2,64*8);
              io.vdc_satb = 1
              io.vdc_status = io.vdc_status AND NOT vdc_SATBfinish
           END IF

           IF (RET = INT.IRQ) THEN
               io.vdc_pendvsync = 1
           ELSE
              IF (vblankon) THEN
                   RET = INT.IRQ
              END IF
           END IF
    
    ELSE
      IF (scanline = min(maxline + 5, scanlines_per_frame - 1)) THEN
          IF (io.vdc_satb) THEN
              io.vdc_status = io.vdc_status OR vdc_SATBfinish
              io.vdc_satb = 0
              IF (SATBIntON) THEN
                
                 RET = INT.IRQ
              END IF
'/*      } else {
'            io.vdc_status&=~VDC_SATBfinish;
'            io.vdc_satb = 0;
'*/      }
         END IF
     
      ELSE
         IF (io.vdc_pendvsync <> 0 AND RET <> INT.IRQ) THEN
             io.vdc_pendvsync = 0
             
             IF (vblankon) THEN
             
                 RET = INT.IRQ
             END IF
         END IF
      END IF
    END IF
    IF (RET = INT.IRQ) THEN
        IF ((io.irq_mask AND IRQ1) = 0) THEN
            io.irq_status = io.irq_status OR IRQ1


            loop6502 = RET: EXIT FUNCTION
            'return ret;
        END IF
    END IF
    loop6502 = int.none: EXIT FUNCTION
'}

END FUNCTION

STATIC SUB M.CMP (rg1, rg2)
  A% = rg1 - rg2
  IF A% AND &HFF00 THEN REG.P = REG.P AND cn.flag ELSE REG.P = REG.P OR c.flag
  A% = A% AND &HFF  'low byte
  REG.ZF = A%
  REG.NF = A%
END SUB

SUB M.JR ()
'op6502 is offset
I = op6502(REG.pc.w)
I = I + (I > 127) * 256
REG.pc.w = REG.pc.w + I + 1
cycle = cycle + 2
END SUB

SUB M.LDWORD (rg&)
rg& = op6502w&(REG.pc.w)
REG.pc.w = REG.pc.w + 2
END SUB

FUNCTION MCZp ()
MCZp = nop6502 + zp
END FUNCTION

FUNCTION MCZx ()
MCZx = nop6502 + REG.X + zp
END FUNCTION

FUNCTION MCZY ()
MCZY = nop6502 + REG.Y + zp
END FUNCTION

SUB mfl (rg)
  rg = rg AND &HFF  'flow control if needed 0 -> ff -> 0
  REG.ZF = rg
  REG.NF = rg

END SUB

FUNCTION min (A, b)
IF A < b THEN min = A ELSE min = b
END FUNCTION

FUNCTION nop6502 ()
'nop6502 = vmmGb(PAGE&(REG.PC.W \ SHD) + REG.PC.W)

A& = vmmGb(PAGE&(REG.pc.w \ SHD) + REG.pc.w)

IF watch = 2 THEN PRINT HEX$(A&); " ";

nop6502 = A&
REG.pc.w = REG.pc.w + 1
END FUNCTION

FUNCTION notb (A%)
notb = NOT (A%) AND &HFF
END FUNCTION

FUNCTION op6502 (A1&)
'a& = a1&
'IF a& < 0 THEN a& = 65536 + a&
'PRINT HEX$(a&); " ";
'op6502 = vmmGb(PAGE&(a1& \ SHD) + a1&)
A& = vmmGb(PAGE&(A1& \ SHD) + A1&)
op6502 = A&
IF watch = 2 THEN PRINT HEX$(A&); " ";
END FUNCTION

FUNCTION op6502w& (A1&)
'retrieve unsigned integer
'error h,l order?
'a1% = op6502(A&)'l
'a2% = op6502(A& + 1)'h
'OP6502W& = a1% + a2% * 2 ^ 8

A& = vmmGw(PAGE&(A1& \ SHD) + A1&)
IF A& < 0 THEN A& = A& + 65536
op6502w& = A&
IF watch = 2 THEN PRINT HEX$(A&); " ";

END FUNCTION

FUNCTION RAMG% (A&)
RAMG% = vmmGb(RAM& + A&)
END FUNCTION

FUNCTION ramGw& (A&)
A& = vmmGw(RAM& + A&)
IF A& < 0 THEN A& = 65536 + A&
ramGw& = A&
END FUNCTION

SUB RAMp (A&, b%)
'PRINT "RAMP("; HEX$(A&); ")";
vmmPb RAM& + A&, b%
END SUB

FUNCTION Rd6502 (A&)
'PRINT "Rd6502("; HEX$(a&); ")";
'IF a& < 0 THEN a& = 65536 + a&
P = A& \ SHD

IF PAGE&(P) <> ioarea& THEN
ADR& = PAGE&(P) + A&
'Rd6502 = vmmGb(adr&)
A1& = vmmGb(ADR&)
Rd6502 = A1&
IF watch = 2 THEN PRINT HEX$(A1&); " ";
ELSE
Rd6502 = io_read(A&)
END IF
END FUNCTION

SUB RefreshLine (A, b)

PRINT "refresh line", A, b
END SUB

SUB RefreshScreen ()

PRINT "screen refresh"
END SUB

SUB RefreshSprite (A, b, c)

END SUB

SUB REGINC ()
words REG.pc, REG.pc.w + 1
END SUB

SUB RESET6502 ()
  timercount = timerperiod
  REG.iperiod = iperiod
  scanline = 0
  maxline = 255
  minline = 0
  io.vdc_status = 0
  io.vdc_inc = 1
  io.minline = 0
  io.maxline = 255
  io.irq_mask = 0
  io.psg_volume = 0
  io.psg_ch = 0
  io.screen_w = 256
  io.screen_h = 240
   'FOR i = 0 TO 5
   '     io.psg(i, 4) = &H80
   'NEXT i
   cycleold = 0




  REG.MPR(7) = &H0: BANK.SET 7, &H0

   REG.MPR(6) = &H5: BANK.SET 6, &H5

   REG.MPR(5) = &H4: BANK.SET 5, &H4

   REG.MPR(4) = &H3: BANK.SET 4, &H3

   REG.MPR(3) = &H2: BANK.SET 3, &H2

   REG.MPR(2) = &H1: BANK.SET 2, &H1

   REG.MPR(1) = &HF8: BANK.SET 1, &HF8   'ram

   REG.MPR(0) = &HFF: BANK.SET 0, &HFF   'io area
  REG.A = 0: REG.X = 0: REG.Y = 0
  REG.P = I.FLAG

  REG.NF = 0: REG.VF = 0

  REG.ZF = &HFF
  REG.s = &HFF
  REG.pc.w = op6502w&(VEC.RESET)
  'ta.L = op6502(vec.timer)
  'ta.H = op6502(vec.timer + 1)




  REG.icount = REG.iperiod
  REG.irequest = int.none
  REG.AfterCLI = 0
  '//_CycleCount=0;
  '(int)(R->User)=0;
  REG.USER = 0



  
 




END SUB

SUB RUN6502 ()
instr.init
DIM A AS regg
RESET6502

A = REG
A.pc = ta
ts! = TIMER - .01
DO
I = nop6502
cycle = cycle + cycleS(I)
CODES I


'SWAP a, reg: SWAP c&, cycle  'needed to execute timer irq

LOOP
END SUB

STATIC FUNCTION RUN6502A& ()
' static int cyclecountold&;
' extern int TimerPeriod;
' extern int frame;
' unsigned char tmp_str[15];

'#ifdef CHRONO
'  uclock_t t0,t1;
'  unsigned char old_I;
'  extern unsigned nb_used[256],time_used[256];
'#endif
RESET6502
instr.init

 
 DO


    I = nop6502
    
    cycle = cycleS(I)
    

'    #ifdef CHRONO
'      nb_used[old_I=I]++;
'      t0=uclock();
'    #endif

   CODES I
   cycleS& = cycleS& + cycle   'TOTAL # OF CYCLES PROG BEEN UP

'  #ifdef CHRONO
'  t1=uclock();
'  time_used[old_I]+=(unsigned)(t1-t0);
'  #endif




    REG.icount = REG.icount - cycle
     
     REG.CYCLECOUNT = REG.CYCLECOUNT + cycle

    IF (REG.icount <= 0) THEN     'IF CYCLE COUNTER EXPIRED

      '/* If we have come after CLI, get INT_? from IRequest */
      '/* Otherwise, get it from the loop handler            */
      IF (REG.AfterCLI) THEN


        IF (REG.irequest AND INT.TIMER) THEN
             REG.irequest = REG.irequest AND NOT INT.TIMER
             I = INT.TIMER


        ELSE

          IF (REG.irequest AND INT.IRQ) THEN
             REG.irequest = REG.irequest AND NOT INT.IRQ
             I = INT.IRQ
          ELSE
             IF (REG.irequest AND INT.IRQ2) THEN
              REG.irequest = REG.irequest AND NOT INT.IRQ2
              I = INT.IRQ2
             END IF
          END IF
        END IF
        REG.icount = 0

        IF (REG.irequest = 0) THEN
         REG.icount = REG.IBACKUP
         REG.AfterCLI = 0
        END IF

      ELSE


         I = loop6502  '        /* Call the periodic handler */
         REG.icount = REG.icount + REG.iperiod
      END IF
      IF (I = INT.QUIT) THEN RUN6502A = REG.pc.w: EXIT FUNCTION'return(_PC_); /* Exit if INT.QUIT     */
      IF I THEN Int6502 I'              /* Interrupt if needed  */


      IF (REG.CYCLECOUNT - cyclecountold&) > (timerperiod * 2) THEN cyclecountold& = REG.CYCLECOUNT
      

    ELSE

        IF ((REG.CYCLECOUNT - cyclecountold&) >= timerperiod) THEN
            cyclecountold& = (cyclecountold& + timerperiod) AND wrd
            I = TimerInt
            IF I THEN Int6502 I
        END IF

    END IF

  

 LOOP
  '/* Execution stopped */
  'return(_PC_);
 RUN6502A = REG.pc.w
'}

END FUNCTION

FUNCTION TimerInt ()

  IF (io.timer_start) THEN
     io.timer_counter = io.timer_counter - 1
     IF io.timer_counter > 128 THEN
        io.timer_counter = io.timer_reload

        IF NOT (io.irq_mask AND tirq) THEN
           io.irq_status = io.irq_status OR tirq
           TimerInt = INT.TIMER
           EXIT FUNCTION
        END IF
     END IF
  END IF
  TimerInt = int.none

END FUNCTION

SUB T_INIT (src&, dist&, LENGTH&)
'a& = word(reg.pc)
A& = REG.pc.w
src& = op6502w&(A&): A& = A& + 2
dist& = op6502w&(A&): A& = A& + 2
LENGTH& = op6502w&(A&): A& = A& + 2
'WORDS REG.PC, A&
REG.pc.w = A&
cycle = LENGTH& * 6
'cycle = cycle + length& * 6
END SUB

FUNCTION vramg (A&)
vramg = vmmGb(vram& + A&)

END FUNCTION

SUB vramp (A&, b%)
vmmPb vram& + A&, b%
END SUB

FUNCTION word& (rg AS pcc)
'A% = CVI(CHR$(RG.L) + CHR$(RG.H))
'WORD& = CVL(MKI$(A%) + MKI$(0))

rg.w = rg.l + rg.h * SH8
word& = rg.w

'word& = rg.l + rg.h * SH8

'word& = CVL(CHR$(RG.l) + CHR$(RG.h) + MKI$(0))



END FUNCTION

SUB words (rg AS pcc, A1&)
A& = A1&
IF A& < 0 THEN A& = 65536 + A&
A& = A& AND &HFFFF
rg.l = A& AND &HFF
rg.h = A& \ SH8
rg.w = A&
END SUB

SUB Wr6502 (A&, V)
'PRINT "Wr6502("; HEX$(a&); ")";
P = A& \ SHD
IF PAGE&(P) <> ioarea& THEN
vmmPb PAGE&(P) + A&, V
ELSE
io_write A&, V
END IF
END SUB

